/* BtReceiver.c generated by valac 0.56.14, the Vala compiler
 * generated from BtReceiver.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Torikulhabib <torik.habib@gamail.com>
 *
 */

#include <granite.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BT_RECEIVER (bt_receiver_get_type ())
#define BT_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BT_RECEIVER, BtReceiver))
#define BT_RECEIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BT_RECEIVER, BtReceiverClass))
#define IS_BT_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BT_RECEIVER))
#define IS_BT_RECEIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BT_RECEIVER))
#define BT_RECEIVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BT_RECEIVER, BtReceiverClass))

typedef struct _BtReceiver BtReceiver;
typedef struct _BtReceiverClass BtReceiverClass;
typedef struct _BtReceiverPrivate BtReceiverPrivate;

#define BLUETOOTH_OBEX_TYPE_TRANSFER (bluetooth_obex_transfer_get_type ())
#define BLUETOOTH_OBEX_TRANSFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_OBEX_TYPE_TRANSFER, BluetoothObexTransfer))
#define BLUETOOTH_OBEX_IS_TRANSFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_OBEX_TYPE_TRANSFER))
#define BLUETOOTH_OBEX_TRANSFER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_OBEX_TYPE_TRANSFER, BluetoothObexTransferIface))

typedef struct _BluetoothObexTransfer BluetoothObexTransfer;
typedef struct _BluetoothObexTransferIface BluetoothObexTransferIface;

#define BLUETOOTH_OBEX_TYPE_TRANSFER_PROXY (bluetooth_obex_transfer_proxy_get_type ())
enum  {
	BT_RECEIVER_0_PROPERTY,
	BT_RECEIVER_SESSION_PROPERTY,
	BT_RECEIVER_NUM_PROPERTIES
};
static GParamSpec* bt_receiver_properties[BT_RECEIVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _BluetoothObexTransferIface {
	GTypeInterface parent_iface;
	void (*cancel) (BluetoothObexTransfer* self, GError** error);
	void (*resume) (BluetoothObexTransfer* self, GError** error);
	void (*suspend) (BluetoothObexTransfer* self, GError** error);
	gchar* (*get_status) (BluetoothObexTransfer* self);
	char* (*get_session) (BluetoothObexTransfer* self);
	gchar* (*get_name) (BluetoothObexTransfer* self);
	gchar* (*get_Type) (BluetoothObexTransfer* self);
	guint64 (*get_time) (BluetoothObexTransfer* self);
	guint64 (*get_size) (BluetoothObexTransfer* self);
	guint64 (*get_transferred) (BluetoothObexTransfer* self);
	gchar* (*get_filename) (BluetoothObexTransfer* self);
};

struct _BtReceiver {
	GraniteDialog parent_instance;
	BtReceiverPrivate * priv;
	BluetoothObexTransfer* transfer;
};

struct _BtReceiverClass {
	GraniteDialogClass parent_class;
};

struct _BtReceiverPrivate {
	GtkProgressBar* progressbar;
	GtkLabel* device_label;
	GtkLabel* directory_label;
	GtkLabel* progress_label;
	GtkLabel* filename_label;
	GtkLabel* rate_label;
	GtkImage* device_image;
	GNotification* notification;
	gchar* path_folder;
	gchar* _session;
	gint start_time;
	guint64 total_size;
};

static gint BtReceiver_private_offset;
static gpointer bt_receiver_parent_class = NULL;

VALA_EXTERN GType bt_receiver_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BtReceiver, g_object_unref)
VALA_EXTERN GType bluetooth_obex_transfer_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint bluetooth_obex_transfer_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType bluetooth_obex_transfer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothObexTransfer, g_object_unref)
VALA_EXTERN BtReceiver* bt_receiver_new (GtkApplication* application);
VALA_EXTERN BtReceiver* bt_receiver_construct (GType object_type,
                                   GtkApplication* application);
VALA_EXTERN void bt_receiver_set_transfer (BtReceiver* self,
                               const gchar* devicename,
                               const gchar* deviceicon,
                               const gchar* objectpath);
static void ___lambda17_ (BtReceiver* self,
                   GVariant* changed,
                   gchar** invalid);
static void bt_receiver_tranfer_progress (BtReceiver* self);
static void ____lambda17__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                      GVariant* changed_properties,
                                                      gchar** invalidated_properties,
                                                      gpointer self);
VALA_EXTERN guint64 bluetooth_obex_transfer_get_size (BluetoothObexTransfer* self);
VALA_EXTERN char* bluetooth_obex_transfer_get_session (BluetoothObexTransfer* self);
VALA_EXTERN void bt_receiver_set_session (BtReceiver* self,
                              const gchar* value);
VALA_EXTERN gchar* bluetooth_obex_transfer_get_name (BluetoothObexTransfer* self);
VALA_EXTERN gchar* bluetooth_obex_transfer_get_status (BluetoothObexTransfer* self);
VALA_EXTERN gchar* bluetooth_obex_transfer_get_filename (BluetoothObexTransfer* self);
static void bt_receiver_on_transfer_progress (BtReceiver* self,
                                       guint64 transferred);
VALA_EXTERN guint64 bluetooth_obex_transfer_get_transferred (BluetoothObexTransfer* self);
static void bt_receiver_move_to_folder (BtReceiver* self,
                                 const gchar* file,
                                 GError** error);
static GFile* bt_receiver_change_name (BtReceiver* self,
                                const gchar* uri);
static gchar* bt_receiver_format_time (BtReceiver* self,
                                gint seconds);
VALA_EXTERN const gchar* bt_receiver_get_session (BtReceiver* self);
static GObject * bt_receiver_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _bt_receiver___lambda18_ (BtReceiver* self,
                               gint response_id);
VALA_EXTERN void bluetooth_obex_transfer_cancel (BluetoothObexTransfer* self,
                                     GError** error);
static void __bt_receiver___lambda18__gtk_dialog_response (GtkDialog* _sender,
                                                    gint response_id,
                                                    gpointer self);
static gboolean _bt_receiver___lambda19_ (BtReceiver* self);
static gboolean __bt_receiver___lambda19__gtk_widget_delete_event (GtkWidget* _sender,
                                                            GdkEventAny* event,
                                                            gpointer self);
static void bt_receiver_finalize (GObject * obj);
static GType bt_receiver_get_type_once (void);
static void _vala_bt_receiver_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_bt_receiver_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
bt_receiver_get_instance_private (BtReceiver* self)
{
	return G_STRUCT_MEMBER_P (self, BtReceiver_private_offset);
}

BtReceiver*
bt_receiver_construct (GType object_type,
                       GtkApplication* application)
{
	BtReceiver * self = NULL;
#line 38 "../ebt/Dialog/BtReceiver.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 39 "../ebt/Dialog/BtReceiver.vala"
	self = (BtReceiver*) g_object_new (object_type, "application", application, "resizable", FALSE, NULL);
#line 38 "../ebt/Dialog/BtReceiver.vala"
	return self;
#line 207 "BtReceiver.c"
}

BtReceiver*
bt_receiver_new (GtkApplication* application)
{
#line 38 "../ebt/Dialog/BtReceiver.vala"
	return bt_receiver_construct (TYPE_BT_RECEIVER, application);
#line 215 "BtReceiver.c"
}

static void
___lambda17_ (BtReceiver* self,
              GVariant* changed,
              gchar** invalid)
{
#line 143 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (changed != NULL);
#line 144 "../ebt/Dialog/BtReceiver.vala"
	bt_receiver_tranfer_progress (self);
#line 227 "BtReceiver.c"
}

static void
____lambda17__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                 GVariant* changed_properties,
                                                 gchar** invalidated_properties,
                                                 gpointer self)
{
#line 143 "../ebt/Dialog/BtReceiver.vala"
	___lambda17_ ((BtReceiver*) self, changed_properties, invalidated_properties);
#line 238 "BtReceiver.c"
}

void
bt_receiver_set_transfer (BtReceiver* self,
                          const gchar* devicename,
                          const gchar* deviceicon,
                          const gchar* objectpath)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	GtkImage* _tmp8_;
	GThemedIcon* _tmp9_;
	GThemedIcon* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 136 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (self != NULL);
#line 136 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (devicename != NULL);
#line 136 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (deviceicon != NULL);
#line 136 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (objectpath != NULL);
#line 137 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = self->priv->device_label;
#line 137 "../ebt/Dialog/BtReceiver.vala"
	_tmp1_ = g_markup_printf_escaped (_ ("<b>From</b>: %s"), devicename);
#line 137 "../ebt/Dialog/BtReceiver.vala"
	_tmp2_ = _tmp1_;
#line 137 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_markup (_tmp0_, _tmp2_);
#line 137 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp2_);
#line 138 "../ebt/Dialog/BtReceiver.vala"
	_tmp3_ = self->priv->directory_label;
#line 138 "../ebt/Dialog/BtReceiver.vala"
	_tmp4_ = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
#line 138 "../ebt/Dialog/BtReceiver.vala"
	_tmp5_ = g_markup_printf_escaped (_ ("<b>To</b>: %s"), _tmp4_);
#line 138 "../ebt/Dialog/BtReceiver.vala"
	_tmp6_ = _tmp5_;
#line 138 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_label (_tmp3_, _tmp6_);
#line 138 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp6_);
#line 139 "../ebt/Dialog/BtReceiver.vala"
	if (deviceicon == NULL) {
#line 139 "../ebt/Dialog/BtReceiver.vala"
		_tmp7_ = "bluetooth";
#line 293 "BtReceiver.c"
	} else {
#line 139 "../ebt/Dialog/BtReceiver.vala"
		_tmp7_ = deviceicon;
#line 297 "BtReceiver.c"
	}
#line 139 "../ebt/Dialog/BtReceiver.vala"
	_tmp8_ = self->priv->device_image;
#line 139 "../ebt/Dialog/BtReceiver.vala"
	_tmp9_ = (GThemedIcon*) g_themed_icon_new (_tmp7_);
#line 139 "../ebt/Dialog/BtReceiver.vala"
	_tmp10_ = _tmp9_;
#line 139 "../ebt/Dialog/BtReceiver.vala"
	gtk_image_set_from_gicon (_tmp8_, (GIcon*) _tmp10_, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 139 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (_tmp10_);
#line 140 "../ebt/Dialog/BtReceiver.vala"
	self->priv->start_time = (gint) g_get_real_time ();
#line 311 "BtReceiver.c"
	{
		BluetoothObexTransfer* _tmp11_ = NULL;
		BluetoothObexTransfer* _tmp12_;
		BluetoothObexTransfer* _tmp13_;
		BluetoothObexTransfer* _tmp14_;
		BluetoothObexTransfer* _tmp15_;
		guint64 _tmp16_;
		guint64 _tmp17_;
		BluetoothObexTransfer* _tmp18_;
		char* _tmp19_;
		char* _tmp20_;
		char* _tmp21_;
		GtkLabel* _tmp22_;
		BluetoothObexTransfer* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 142 "../ebt/Dialog/BtReceiver.vala"
		_tmp12_ = (BluetoothObexTransfer*) g_initable_new (BLUETOOTH_OBEX_TYPE_TRANSFER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.bluez.obex", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", objectpath, "g-interface-name", "org.bluez.obex.Transfer1", NULL);
#line 142 "../ebt/Dialog/BtReceiver.vala"
		_tmp11_ = (BluetoothObexTransfer*) _tmp12_;
#line 142 "../ebt/Dialog/BtReceiver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 337 "BtReceiver.c"
			goto __catch0_g_error;
		}
#line 142 "../ebt/Dialog/BtReceiver.vala"
		_tmp13_ = _tmp11_;
#line 142 "../ebt/Dialog/BtReceiver.vala"
		_tmp11_ = NULL;
#line 142 "../ebt/Dialog/BtReceiver.vala"
		_g_object_unref0 (self->transfer);
#line 142 "../ebt/Dialog/BtReceiver.vala"
		self->transfer = _tmp13_;
#line 143 "../ebt/Dialog/BtReceiver.vala"
		_tmp14_ = self->transfer;
#line 143 "../ebt/Dialog/BtReceiver.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) ____lambda17__g_dbus_proxy_g_properties_changed, self, 0);
#line 146 "../ebt/Dialog/BtReceiver.vala"
		_tmp15_ = self->transfer;
#line 146 "../ebt/Dialog/BtReceiver.vala"
		_tmp16_ = bluetooth_obex_transfer_get_size (_tmp15_);
#line 146 "../ebt/Dialog/BtReceiver.vala"
		_tmp17_ = _tmp16_;
#line 146 "../ebt/Dialog/BtReceiver.vala"
		self->priv->total_size = _tmp17_;
#line 147 "../ebt/Dialog/BtReceiver.vala"
		_tmp18_ = self->transfer;
#line 147 "../ebt/Dialog/BtReceiver.vala"
		_tmp19_ = bluetooth_obex_transfer_get_session (_tmp18_);
#line 147 "../ebt/Dialog/BtReceiver.vala"
		_tmp20_ = _tmp19_;
#line 147 "../ebt/Dialog/BtReceiver.vala"
		_tmp21_ = _tmp20_;
#line 147 "../ebt/Dialog/BtReceiver.vala"
		bt_receiver_set_session (self, (const gchar*) _tmp21_);
#line 147 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (_tmp21_);
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp22_ = self->priv->filename_label;
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp23_ = self->transfer;
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp24_ = bluetooth_obex_transfer_get_name (_tmp23_);
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp25_ = _tmp24_;
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp26_ = _tmp25_;
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp27_ = g_markup_printf_escaped (_ ("<b>Filename</b>: %s"), _tmp26_);
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_tmp28_ = _tmp27_;
#line 148 "../ebt/Dialog/BtReceiver.vala"
		gtk_label_set_markup (_tmp22_, _tmp28_);
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (_tmp28_);
#line 148 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (_tmp26_);
#line 141 "../ebt/Dialog/BtReceiver.vala"
		_g_object_unref0 (_tmp11_);
#line 394 "BtReceiver.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
#line 141 "../ebt/Dialog/BtReceiver.vala"
		e = _inner_error0_;
#line 141 "../ebt/Dialog/BtReceiver.vala"
		_inner_error0_ = NULL;
#line 150 "../ebt/Dialog/BtReceiver.vala"
		_tmp29_ = e;
#line 150 "../ebt/Dialog/BtReceiver.vala"
		_tmp30_ = _tmp29_->message;
#line 150 "../ebt/Dialog/BtReceiver.vala"
		g_warning ("BtReceiver.vala:150: %s", _tmp30_);
#line 141 "../ebt/Dialog/BtReceiver.vala"
		_g_error_free0 (e);
#line 414 "BtReceiver.c"
	}
	__finally0:
#line 141 "../ebt/Dialog/BtReceiver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../ebt/Dialog/BtReceiver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../ebt/Dialog/BtReceiver.vala"
		g_clear_error (&_inner_error0_);
#line 141 "../ebt/Dialog/BtReceiver.vala"
		return;
#line 425 "BtReceiver.c"
	}
}

static void
bt_receiver_tranfer_progress (BtReceiver* self)
{
	GError* _inner_error0_ = NULL;
#line 153 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (self != NULL);
#line 435 "BtReceiver.c"
	{
		BluetoothObexTransfer* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GQuark _tmp5_ = 0U;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		static GQuark _tmp4_label0 = 0;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		static GQuark _tmp4_label1 = 0;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		static GQuark _tmp4_label2 = 0;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		static GQuark _tmp4_label3 = 0;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		_tmp0_ = self->transfer;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		_tmp1_ = bluetooth_obex_transfer_get_status (_tmp0_);
#line 155 "../ebt/Dialog/BtReceiver.vala"
		_tmp2_ = _tmp1_;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		_tmp3_ = _tmp2_;
#line 155 "../ebt/Dialog/BtReceiver.vala"
		_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 155 "../ebt/Dialog/BtReceiver.vala"
		g_free (_tmp3_);
#line 155 "../ebt/Dialog/BtReceiver.vala"
		if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("error")))) {
#line 155 "../ebt/Dialog/BtReceiver.vala"
			switch (0) {
#line 466 "BtReceiver.c"
				default:
				{
					GNotification* _tmp6_;
					GtkImage* _tmp7_;
					GIcon* _tmp8_;
					GIcon* _tmp9_;
					GIcon* _tmp10_;
					GNotification* _tmp11_;
					GNotification* _tmp12_;
					GtkLabel* _tmp13_;
					const gchar* _tmp14_;
					BluetoothObexTransfer* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					GtkWidget* _tmp21_;
					GtkApplication* _tmp22_;
					GtkApplication* _tmp23_;
					GNotification* _tmp24_;
#line 157 "../ebt/Dialog/BtReceiver.vala"
					_tmp6_ = self->priv->notification;
#line 157 "../ebt/Dialog/BtReceiver.vala"
					_tmp7_ = self->priv->device_image;
#line 157 "../ebt/Dialog/BtReceiver.vala"
					g_object_get (_tmp7_, "gicon", &_tmp8_, NULL);
#line 157 "../ebt/Dialog/BtReceiver.vala"
					_tmp9_ = _tmp8_;
#line 157 "../ebt/Dialog/BtReceiver.vala"
					_tmp10_ = _tmp9_;
#line 157 "../ebt/Dialog/BtReceiver.vala"
					g_notification_set_icon (_tmp6_, _tmp10_);
#line 157 "../ebt/Dialog/BtReceiver.vala"
					_g_object_unref0 (_tmp10_);
#line 158 "../ebt/Dialog/BtReceiver.vala"
					_tmp11_ = self->priv->notification;
#line 158 "../ebt/Dialog/BtReceiver.vala"
					g_notification_set_title (_tmp11_, _ ("File transfer failed"));
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp12_ = self->priv->notification;
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp13_ = self->priv->device_label;
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp14_ = gtk_label_get_label (_tmp13_);
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp15_ = self->transfer;
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp16_ = bluetooth_obex_transfer_get_name (_tmp15_);
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp17_ = _tmp16_;
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp18_ = _tmp17_;
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp19_ = g_markup_printf_escaped (_ ("%s <b>File:</b> %s not received"), _tmp14_, _tmp18_);
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_tmp20_ = _tmp19_;
#line 159 "../ebt/Dialog/BtReceiver.vala"
					g_notification_set_body (_tmp12_, _tmp20_);
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_g_free0 (_tmp20_);
#line 159 "../ebt/Dialog/BtReceiver.vala"
					_g_free0 (_tmp18_);
#line 160 "../ebt/Dialog/BtReceiver.vala"
					_tmp21_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 160 "../ebt/Dialog/BtReceiver.vala"
					_tmp22_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_window_get_type (), GtkWindow));
#line 160 "../ebt/Dialog/BtReceiver.vala"
					_tmp23_ = _tmp22_;
#line 160 "../ebt/Dialog/BtReceiver.vala"
					_tmp24_ = self->priv->notification;
#line 160 "../ebt/Dialog/BtReceiver.vala"
					g_application_send_notification ((GApplication*) _tmp23_, "io.elementary.bluetooth", _tmp24_);
#line 161 "../ebt/Dialog/BtReceiver.vala"
					gtk_widget_destroy ((GtkWidget*) self);
#line 162 "../ebt/Dialog/BtReceiver.vala"
					break;
#line 544 "BtReceiver.c"
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("queued")))) {
#line 155 "../ebt/Dialog/BtReceiver.vala"
			switch (0) {
#line 550 "BtReceiver.c"
				default:
				{
#line 164 "../ebt/Dialog/BtReceiver.vala"
					break;
#line 555 "BtReceiver.c"
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("active")))) {
#line 155 "../ebt/Dialog/BtReceiver.vala"
			switch (0) {
#line 561 "BtReceiver.c"
				default:
				{
					gchar* path = NULL;
					BluetoothObexTransfer* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					const gchar* _tmp28_;
					BluetoothObexTransfer* _tmp31_;
					guint64 _tmp32_;
					guint64 _tmp33_;
#line 166 "../ebt/Dialog/BtReceiver.vala"
					_tmp25_ = self->transfer;
#line 166 "../ebt/Dialog/BtReceiver.vala"
					_tmp26_ = bluetooth_obex_transfer_get_filename (_tmp25_);
#line 166 "../ebt/Dialog/BtReceiver.vala"
					_tmp27_ = _tmp26_;
#line 166 "../ebt/Dialog/BtReceiver.vala"
					path = _tmp27_;
#line 167 "../ebt/Dialog/BtReceiver.vala"
					_tmp28_ = path;
#line 167 "../ebt/Dialog/BtReceiver.vala"
					if (_tmp28_ != NULL) {
#line 584 "BtReceiver.c"
						const gchar* _tmp29_;
						gchar* _tmp30_;
#line 168 "../ebt/Dialog/BtReceiver.vala"
						_tmp29_ = path;
#line 168 "../ebt/Dialog/BtReceiver.vala"
						_tmp30_ = g_strdup (_tmp29_);
#line 168 "../ebt/Dialog/BtReceiver.vala"
						_g_free0 (self->priv->path_folder);
#line 168 "../ebt/Dialog/BtReceiver.vala"
						self->priv->path_folder = _tmp30_;
#line 595 "BtReceiver.c"
					}
#line 170 "../ebt/Dialog/BtReceiver.vala"
					_tmp31_ = self->transfer;
#line 170 "../ebt/Dialog/BtReceiver.vala"
					_tmp32_ = bluetooth_obex_transfer_get_transferred (_tmp31_);
#line 170 "../ebt/Dialog/BtReceiver.vala"
					_tmp33_ = _tmp32_;
#line 170 "../ebt/Dialog/BtReceiver.vala"
					bt_receiver_on_transfer_progress (self, _tmp33_);
#line 171 "../ebt/Dialog/BtReceiver.vala"
					_g_free0 (path);
#line 171 "../ebt/Dialog/BtReceiver.vala"
					break;
#line 609 "BtReceiver.c"
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("complete")))) {
#line 155 "../ebt/Dialog/BtReceiver.vala"
			switch (0) {
#line 615 "BtReceiver.c"
				default:
				{
					const gchar* _tmp34_;
#line 173 "../ebt/Dialog/BtReceiver.vala"
					_tmp34_ = self->priv->path_folder;
#line 173 "../ebt/Dialog/BtReceiver.vala"
					bt_receiver_move_to_folder (self, _tmp34_, &_inner_error0_);
#line 173 "../ebt/Dialog/BtReceiver.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 625 "BtReceiver.c"
						goto __catch0_g_error;
					}
#line 174 "../ebt/Dialog/BtReceiver.vala"
					gtk_widget_destroy ((GtkWidget*) self);
#line 175 "../ebt/Dialog/BtReceiver.vala"
					break;
#line 632 "BtReceiver.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp35_;
		const gchar* _tmp36_;
#line 154 "../ebt/Dialog/BtReceiver.vala"
		e = _inner_error0_;
#line 154 "../ebt/Dialog/BtReceiver.vala"
		_inner_error0_ = NULL;
#line 178 "../ebt/Dialog/BtReceiver.vala"
		_tmp35_ = e;
#line 178 "../ebt/Dialog/BtReceiver.vala"
		_tmp36_ = _tmp35_->message;
#line 178 "../ebt/Dialog/BtReceiver.vala"
		g_critical ("BtReceiver.vala:178: %s", _tmp36_);
#line 154 "../ebt/Dialog/BtReceiver.vala"
		_g_error_free0 (e);
#line 655 "BtReceiver.c"
	}
	__finally0:
#line 154 "../ebt/Dialog/BtReceiver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../ebt/Dialog/BtReceiver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../ebt/Dialog/BtReceiver.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../ebt/Dialog/BtReceiver.vala"
		return;
#line 666 "BtReceiver.c"
	}
}

static void
bt_receiver_move_to_folder (BtReceiver* self,
                            const gchar* file,
                            GError** error)
{
	GFile* src = NULL;
	GFile* _tmp0_;
	GFile* dest = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GNotification* _tmp8_;
	GtkImage* _tmp9_;
	GIcon* _tmp10_;
	GIcon* _tmp11_;
	GIcon* _tmp12_;
	GNotification* _tmp13_;
	GNotification* _tmp14_;
	GtkLabel* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkWidget* _tmp21_;
	GtkApplication* _tmp22_;
	GtkApplication* _tmp23_;
	GNotification* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 181 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (self != NULL);
#line 181 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (file != NULL);
#line 182 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = g_file_new_for_path (file);
#line 182 "../ebt/Dialog/BtReceiver.vala"
	src = _tmp0_;
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp1_ = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp2_ = g_file_get_basename (src);
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp3_ = _tmp2_;
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp4_ = g_build_filename (_tmp1_, _tmp3_, NULL);
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp5_ = _tmp4_;
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp6_ = bt_receiver_change_name (self, _tmp5_);
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_tmp7_ = _tmp6_;
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp5_);
#line 183 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp3_);
#line 183 "../ebt/Dialog/BtReceiver.vala"
	dest = _tmp7_;
#line 184 "../ebt/Dialog/BtReceiver.vala"
	g_file_move (src, dest, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
#line 184 "../ebt/Dialog/BtReceiver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../ebt/Dialog/BtReceiver.vala"
		g_propagate_error (error, _inner_error0_);
#line 184 "../ebt/Dialog/BtReceiver.vala"
		_g_object_unref0 (dest);
#line 184 "../ebt/Dialog/BtReceiver.vala"
		_g_object_unref0 (src);
#line 184 "../ebt/Dialog/BtReceiver.vala"
		return;
#line 743 "BtReceiver.c"
	}
#line 185 "../ebt/Dialog/BtReceiver.vala"
	_tmp8_ = self->priv->notification;
#line 185 "../ebt/Dialog/BtReceiver.vala"
	_tmp9_ = self->priv->device_image;
#line 185 "../ebt/Dialog/BtReceiver.vala"
	g_object_get (_tmp9_, "gicon", &_tmp10_, NULL);
#line 185 "../ebt/Dialog/BtReceiver.vala"
	_tmp11_ = _tmp10_;
#line 185 "../ebt/Dialog/BtReceiver.vala"
	_tmp12_ = _tmp11_;
#line 185 "../ebt/Dialog/BtReceiver.vala"
	g_notification_set_icon (_tmp8_, _tmp12_);
#line 185 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (_tmp12_);
#line 186 "../ebt/Dialog/BtReceiver.vala"
	_tmp13_ = self->priv->notification;
#line 186 "../ebt/Dialog/BtReceiver.vala"
	g_notification_set_title (_tmp13_, _ ("File transferred successfully"));
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp14_ = self->priv->notification;
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp15_ = self->priv->device_label;
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp16_ = gtk_label_get_label (_tmp15_);
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp17_ = g_file_get_path (dest);
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp18_ = _tmp17_;
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp19_ = g_markup_printf_escaped (_ ("%s <b>Save to:</b> %s"), _tmp16_, _tmp18_);
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_tmp20_ = _tmp19_;
#line 187 "../ebt/Dialog/BtReceiver.vala"
	g_notification_set_body (_tmp14_, _tmp20_);
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp20_);
#line 187 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp18_);
#line 188 "../ebt/Dialog/BtReceiver.vala"
	_tmp21_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 188 "../ebt/Dialog/BtReceiver.vala"
	_tmp22_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_window_get_type (), GtkWindow));
#line 188 "../ebt/Dialog/BtReceiver.vala"
	_tmp23_ = _tmp22_;
#line 188 "../ebt/Dialog/BtReceiver.vala"
	_tmp24_ = self->priv->notification;
#line 188 "../ebt/Dialog/BtReceiver.vala"
	g_application_send_notification ((GApplication*) _tmp23_, "io.elementary.bluetooth", _tmp24_);
#line 181 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (dest);
#line 181 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (src);
#line 797 "BtReceiver.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1152 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1152 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1154 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1154 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 821 "BtReceiver.c"
		gchar* _tmp2_;
#line 1155 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1155 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1155 "glib-2.0.vapi"
		return result;
#line 829 "BtReceiver.c"
	} else {
#line 1157 "glib-2.0.vapi"
		result = -1;
#line 1157 "glib-2.0.vapi"
		return result;
#line 835 "BtReceiver.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 863 "BtReceiver.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 869 "BtReceiver.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 875 "BtReceiver.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 879 "BtReceiver.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 887 "BtReceiver.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 891 "BtReceiver.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 903 "BtReceiver.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 926 "BtReceiver.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 935 "BtReceiver.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 954 "BtReceiver.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 958 "BtReceiver.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 964 "BtReceiver.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 974 "BtReceiver.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 982 "BtReceiver.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 986 "BtReceiver.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 992 "BtReceiver.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1002 "BtReceiver.c"
}

static GFile*
bt_receiver_change_name (BtReceiver* self,
                         const gchar* uri)
{
	GFile* file_check = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 191 "../ebt/Dialog/BtReceiver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../ebt/Dialog/BtReceiver.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 192 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = g_file_new_for_path (uri);
#line 192 "../ebt/Dialog/BtReceiver.vala"
	file_check = _tmp0_;
#line 193 "../ebt/Dialog/BtReceiver.vala"
	_tmp1_ = file_check;
#line 193 "../ebt/Dialog/BtReceiver.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 1025 "BtReceiver.c"
		gchar* without_ext = NULL;
		gint last_dot = 0;
		gint last_slash = 0;
		gchar* ext_name = NULL;
		gchar* _tmp4_;
		gchar* time = NULL;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 195 "../ebt/Dialog/BtReceiver.vala"
		last_dot = string_last_index_of (uri, ".", 0);
#line 196 "../ebt/Dialog/BtReceiver.vala"
		last_slash = string_last_index_of (uri, "/", 0);
#line 197 "../ebt/Dialog/BtReceiver.vala"
		if (last_dot < last_slash) {
#line 1051 "BtReceiver.c"
			gchar* _tmp2_;
#line 198 "../ebt/Dialog/BtReceiver.vala"
			_tmp2_ = g_strdup (uri);
#line 198 "../ebt/Dialog/BtReceiver.vala"
			_g_free0 (without_ext);
#line 198 "../ebt/Dialog/BtReceiver.vala"
			without_ext = _tmp2_;
#line 1059 "BtReceiver.c"
		} else {
			gchar* _tmp3_;
#line 200 "../ebt/Dialog/BtReceiver.vala"
			_tmp3_ = string_slice (uri, (glong) 0, (glong) last_dot);
#line 200 "../ebt/Dialog/BtReceiver.vala"
			_g_free0 (without_ext);
#line 200 "../ebt/Dialog/BtReceiver.vala"
			without_ext = _tmp3_;
#line 1068 "BtReceiver.c"
		}
#line 202 "../ebt/Dialog/BtReceiver.vala"
		_tmp4_ = string_substring (uri, (glong) last_dot, (glong) -1);
#line 202 "../ebt/Dialog/BtReceiver.vala"
		ext_name = _tmp4_;
#line 203 "../ebt/Dialog/BtReceiver.vala"
		_tmp5_ = g_date_time_new_now_local ();
#line 203 "../ebt/Dialog/BtReceiver.vala"
		_tmp6_ = _tmp5_;
#line 203 "../ebt/Dialog/BtReceiver.vala"
		_tmp7_ = g_date_time_format (_tmp6_, " (%F %H:%M:%S)");
#line 203 "../ebt/Dialog/BtReceiver.vala"
		_tmp8_ = _tmp7_;
#line 203 "../ebt/Dialog/BtReceiver.vala"
		_g_date_time_unref0 (_tmp6_);
#line 203 "../ebt/Dialog/BtReceiver.vala"
		time = _tmp8_;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp9_ = without_ext;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp10_ = time;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp12_ = _tmp11_;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp13_ = ext_name;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp14_ = g_strconcat (_tmp12_, _tmp13_, NULL);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp15_ = _tmp14_;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_tmp17_ = _tmp16_;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (_tmp15_);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (_tmp12_);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		result = _tmp17_;
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (time);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (ext_name);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (without_ext);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		_g_object_unref0 (file_check);
#line 204 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1120 "BtReceiver.c"
	} else {
#line 206 "../ebt/Dialog/BtReceiver.vala"
		result = file_check;
#line 206 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1126 "BtReceiver.c"
	}
}

static void
bt_receiver_on_transfer_progress (BtReceiver* self,
                                  guint64 transferred)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkProgressBar* _tmp7_;
	gint current_time = 0;
	gint elapsed_time = 0;
	guint64 transfer_rate = 0ULL;
	GtkLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	guint64 remaining_time = 0ULL;
	GtkLabel* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
#line 210 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (self != NULL);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = self->priv->progress_label;
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp1_ = g_format_size_full (transferred, G_FORMAT_SIZE_DEFAULT);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp2_ = _tmp1_;
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp3_ = g_format_size_full (self->priv->total_size, G_FORMAT_SIZE_DEFAULT);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp4_ = _tmp3_;
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp5_ = g_strdup_printf (_ ("Receiving…  %s of %s"), _tmp2_, _tmp4_);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_tmp6_ = _tmp5_;
#line 211 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_label (_tmp0_, _tmp6_);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp6_);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp4_);
#line 211 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp2_);
#line 212 "../ebt/Dialog/BtReceiver.vala"
	_tmp7_ = self->priv->progressbar;
#line 212 "../ebt/Dialog/BtReceiver.vala"
	gtk_progress_bar_set_fraction (_tmp7_, ((gdouble) transferred) / ((gdouble) self->priv->total_size));
#line 213 "../ebt/Dialog/BtReceiver.vala"
	current_time = (gint) g_get_real_time ();
#line 214 "../ebt/Dialog/BtReceiver.vala"
	elapsed_time = (current_time - self->priv->start_time) / 1000000;
#line 215 "../ebt/Dialog/BtReceiver.vala"
	if (current_time < (self->priv->start_time + 1000000)) {
#line 216 "../ebt/Dialog/BtReceiver.vala"
		return;
#line 1196 "BtReceiver.c"
	}
#line 218 "../ebt/Dialog/BtReceiver.vala"
	if (elapsed_time == 0) {
#line 219 "../ebt/Dialog/BtReceiver.vala"
		return;
#line 1202 "BtReceiver.c"
	}
#line 221 "../ebt/Dialog/BtReceiver.vala"
	transfer_rate = transferred / elapsed_time;
#line 222 "../ebt/Dialog/BtReceiver.vala"
	if (transfer_rate == ((guint64) 0)) {
#line 223 "../ebt/Dialog/BtReceiver.vala"
		return;
#line 1210 "BtReceiver.c"
	}
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_tmp8_ = self->priv->rate_label;
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_tmp9_ = g_format_size_full (transfer_rate, G_FORMAT_SIZE_DEFAULT);
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_tmp10_ = _tmp9_;
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_tmp11_ = g_markup_printf_escaped (_ ("<b>Transfer rate:</b> %s"), _tmp10_);
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_tmp12_ = _tmp11_;
#line 225 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_label (_tmp8_, _tmp12_);
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp12_);
#line 225 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp10_);
#line 226 "../ebt/Dialog/BtReceiver.vala"
	remaining_time = (self->priv->total_size - transferred) / transfer_rate;
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp13_ = self->priv->progress_label;
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp14_ = g_format_size_full (transferred, G_FORMAT_SIZE_DEFAULT);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp15_ = _tmp14_;
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp16_ = g_format_size_full (self->priv->total_size, G_FORMAT_SIZE_DEFAULT);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp17_ = _tmp16_;
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp18_ = bt_receiver_format_time (self, (gint) remaining_time);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp19_ = _tmp18_;
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp20_ = g_markup_printf_escaped (_ ("%s of %s received, time remaining %s"), _tmp15_, _tmp17_, _tmp19_);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_tmp21_ = _tmp20_;
#line 227 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_label (_tmp13_, _tmp21_);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp21_);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp19_);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp17_);
#line 227 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp15_);
#line 1258 "BtReceiver.c"
}

static gchar*
bt_receiver_format_time (BtReceiver* self,
                         gint seconds)
{
	gint minutes = 0;
	gint hours = 0;
	gchar* _tmp7_;
	gchar* result;
#line 230 "../ebt/Dialog/BtReceiver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 231 "../ebt/Dialog/BtReceiver.vala"
	if (seconds < 0) {
#line 232 "../ebt/Dialog/BtReceiver.vala"
		seconds = 0;
#line 1275 "BtReceiver.c"
	}
#line 235 "../ebt/Dialog/BtReceiver.vala"
	if (seconds < 60) {
#line 1279 "BtReceiver.c"
		gchar* _tmp0_;
#line 236 "../ebt/Dialog/BtReceiver.vala"
		_tmp0_ = g_strdup_printf (ngettext ("%d second", "%d seconds", (gulong) seconds), seconds);
#line 236 "../ebt/Dialog/BtReceiver.vala"
		result = _tmp0_;
#line 236 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1287 "BtReceiver.c"
	}
#line 240 "../ebt/Dialog/BtReceiver.vala"
	if (seconds < (60 * 60)) {
#line 1291 "BtReceiver.c"
		gchar* _tmp1_;
#line 241 "../ebt/Dialog/BtReceiver.vala"
		minutes = (seconds + 30) / 60;
#line 242 "../ebt/Dialog/BtReceiver.vala"
		_tmp1_ = g_strdup_printf (ngettext ("%d minute", "%d minutes", (gulong) minutes), minutes);
#line 242 "../ebt/Dialog/BtReceiver.vala"
		result = _tmp1_;
#line 242 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1301 "BtReceiver.c"
	}
#line 245 "../ebt/Dialog/BtReceiver.vala"
	hours = seconds / (60 * 60);
#line 246 "../ebt/Dialog/BtReceiver.vala"
	if (seconds < ((60 * 60) * 4)) {
#line 1307 "BtReceiver.c"
		gchar* h = NULL;
		gchar* _tmp2_;
		gchar* m = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 247 "../ebt/Dialog/BtReceiver.vala"
		minutes = ((seconds - ((hours * 60) * 60)) + 30) / 60;
#line 248 "../ebt/Dialog/BtReceiver.vala"
		_tmp2_ = g_strdup_printf (ngettext ("%u hour", "%u hours", (gulong) hours), (guint) hours);
#line 248 "../ebt/Dialog/BtReceiver.vala"
		h = _tmp2_;
#line 249 "../ebt/Dialog/BtReceiver.vala"
		_tmp3_ = g_strdup_printf (ngettext ("%u minute", "%u minutes", (gulong) minutes), (guint) minutes);
#line 249 "../ebt/Dialog/BtReceiver.vala"
		m = _tmp3_;
#line 251 "../ebt/Dialog/BtReceiver.vala"
		_tmp4_ = h;
#line 251 "../ebt/Dialog/BtReceiver.vala"
		_tmp5_ = m;
#line 251 "../ebt/Dialog/BtReceiver.vala"
		_tmp6_ = g_strdup_printf (_ ("%s, %s"), _tmp4_, _tmp5_);
#line 251 "../ebt/Dialog/BtReceiver.vala"
		result = _tmp6_;
#line 251 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (m);
#line 251 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (h);
#line 251 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1339 "BtReceiver.c"
	}
#line 254 "../ebt/Dialog/BtReceiver.vala"
	_tmp7_ = g_strdup_printf (ngettext ("approximately %d hour", "approximately %d hours", (gulong) hours), hours);
#line 254 "../ebt/Dialog/BtReceiver.vala"
	result = _tmp7_;
#line 254 "../ebt/Dialog/BtReceiver.vala"
	return result;
#line 1347 "BtReceiver.c"
}

const gchar*
bt_receiver_get_session (BtReceiver* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../ebt/Dialog/BtReceiver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = self->priv->_session;
#line 34 "../ebt/Dialog/BtReceiver.vala"
	result = _tmp0_;
#line 34 "../ebt/Dialog/BtReceiver.vala"
	return result;
#line 1363 "BtReceiver.c"
}

void
bt_receiver_set_session (BtReceiver* self,
                         const gchar* value)
{
	gchar* old_value;
#line 34 "../ebt/Dialog/BtReceiver.vala"
	g_return_if_fail (self != NULL);
#line 34 "../ebt/Dialog/BtReceiver.vala"
	old_value = bt_receiver_get_session (self);
#line 34 "../ebt/Dialog/BtReceiver.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1377 "BtReceiver.c"
		gchar* _tmp0_;
#line 34 "../ebt/Dialog/BtReceiver.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../ebt/Dialog/BtReceiver.vala"
		_g_free0 (self->priv->_session);
#line 34 "../ebt/Dialog/BtReceiver.vala"
		self->priv->_session = _tmp0_;
#line 34 "../ebt/Dialog/BtReceiver.vala"
		g_object_notify_by_pspec ((GObject *) self, bt_receiver_properties[BT_RECEIVER_SESSION_PROPERTY]);
#line 1387 "BtReceiver.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../ebt/Dialog/BtReceiver.vala"
	return self ? g_object_ref (self) : NULL;
#line 1396 "BtReceiver.c"
}

static void
_bt_receiver___lambda18_ (BtReceiver* self,
                          gint response_id)
{
	GError* _inner_error0_ = NULL;
#line 116 "../ebt/Dialog/BtReceiver.vala"
	if (response_id == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1406 "BtReceiver.c"
		{
			BluetoothObexTransfer* _tmp0_;
#line 118 "../ebt/Dialog/BtReceiver.vala"
			_tmp0_ = self->transfer;
#line 118 "../ebt/Dialog/BtReceiver.vala"
			bluetooth_obex_transfer_cancel (_tmp0_, &_inner_error0_);
#line 118 "../ebt/Dialog/BtReceiver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1415 "BtReceiver.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp1_;
			const gchar* _tmp2_;
#line 117 "../ebt/Dialog/BtReceiver.vala"
			e = _inner_error0_;
#line 117 "../ebt/Dialog/BtReceiver.vala"
			_inner_error0_ = NULL;
#line 120 "../ebt/Dialog/BtReceiver.vala"
			_tmp1_ = e;
#line 120 "../ebt/Dialog/BtReceiver.vala"
			_tmp2_ = _tmp1_->message;
#line 120 "../ebt/Dialog/BtReceiver.vala"
			g_warning ("BtReceiver.vala:120: %s", _tmp2_);
#line 117 "../ebt/Dialog/BtReceiver.vala"
			_g_error_free0 (e);
#line 1437 "BtReceiver.c"
		}
		__finally0:
#line 117 "../ebt/Dialog/BtReceiver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../ebt/Dialog/BtReceiver.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../ebt/Dialog/BtReceiver.vala"
			g_clear_error (&_inner_error0_);
#line 117 "../ebt/Dialog/BtReceiver.vala"
			return;
#line 1448 "BtReceiver.c"
		}
#line 122 "../ebt/Dialog/BtReceiver.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 1452 "BtReceiver.c"
	} else {
#line 124 "../ebt/Dialog/BtReceiver.vala"
		gtk_widget_hide_on_delete ((GtkWidget*) self);
#line 1456 "BtReceiver.c"
	}
}

static void
__bt_receiver___lambda18__gtk_dialog_response (GtkDialog* _sender,
                                               gint response_id,
                                               gpointer self)
{
#line 115 "../ebt/Dialog/BtReceiver.vala"
	_bt_receiver___lambda18_ ((BtReceiver*) self, response_id);
#line 1467 "BtReceiver.c"
}

static gboolean
_bt_receiver___lambda19_ (BtReceiver* self)
{
	BluetoothObexTransfer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 128 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = self->transfer;
#line 128 "../ebt/Dialog/BtReceiver.vala"
	_tmp1_ = bluetooth_obex_transfer_get_status (_tmp0_);
#line 128 "../ebt/Dialog/BtReceiver.vala"
	_tmp2_ = _tmp1_;
#line 128 "../ebt/Dialog/BtReceiver.vala"
	_tmp3_ = _tmp2_;
#line 128 "../ebt/Dialog/BtReceiver.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "active") == 0;
#line 128 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (_tmp3_);
#line 128 "../ebt/Dialog/BtReceiver.vala"
	if (_tmp4_) {
#line 129 "../ebt/Dialog/BtReceiver.vala"
		result = gtk_widget_hide_on_delete ((GtkWidget*) self);
#line 129 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1497 "BtReceiver.c"
	} else {
#line 131 "../ebt/Dialog/BtReceiver.vala"
		result = FALSE;
#line 131 "../ebt/Dialog/BtReceiver.vala"
		return result;
#line 1503 "BtReceiver.c"
	}
}

static gboolean
__bt_receiver___lambda19__gtk_widget_delete_event (GtkWidget* _sender,
                                                   GdkEventAny* event,
                                                   gpointer self)
{
	gboolean result;
	result = _bt_receiver___lambda19_ ((BtReceiver*) self);
#line 127 "../ebt/Dialog/BtReceiver.vala"
	return result;
#line 1516 "BtReceiver.c"
}

static GObject *
bt_receiver_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BtReceiver * self;
	GNotification* _tmp0_;
	GNotification* _tmp1_;
	GtkImage* icon_image = NULL;
	GtkImage* _tmp2_ = NULL;
	GtkImage* _tmp3_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_;
	GtkOverlay* _tmp5_;
	GtkImage* _tmp6_;
	GtkOverlay* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkLabel* _tmp13_ = NULL;
	GtkLabel* _tmp14_ = NULL;
	GtkProgressBar* _tmp15_ = NULL;
	GtkLabel* _tmp16_ = NULL;
	GtkGrid* message_grid = NULL;
	GtkGrid* _tmp17_ = NULL;
	GtkGrid* _tmp18_;
	GtkOverlay* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkProgressBar* _tmp29_;
	GtkGrid* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* _tmp32_;
	GtkGrid* _tmp33_;
	GtkWidget* suggested_button = NULL;
	GtkWidget* _tmp34_;
	GtkWidget* _tmp35_;
	GtkWidget* _tmp36_;
	GtkStyleContext* _tmp37_;
#line 44 "../ebt/Dialog/BtReceiver.vala"
	parent_class = G_OBJECT_CLASS (bt_receiver_parent_class);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BT_RECEIVER, BtReceiver);
#line 45 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = g_notification_new ("bluetooth");
#line 45 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->notification);
#line 45 "../ebt/Dialog/BtReceiver.vala"
	self->priv->notification = _tmp0_;
#line 46 "../ebt/Dialog/BtReceiver.vala"
	_tmp1_ = self->priv->notification;
#line 46 "../ebt/Dialog/BtReceiver.vala"
	g_notification_set_priority (_tmp1_, G_NOTIFICATION_PRIORITY_NORMAL);
#line 48 "../ebt/Dialog/BtReceiver.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("bluetooth", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 48 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 48 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 48 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp2_);
#line 48 "../ebt/Dialog/BtReceiver.vala"
	icon_image = _tmp2_;
#line 53 "../ebt/Dialog/BtReceiver.vala"
	_tmp3_ = (GtkImage*) gtk_image_new ();
#line 53 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
#line 53 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
#line 53 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->device_image);
#line 53 "../ebt/Dialog/BtReceiver.vala"
	self->priv->device_image = _tmp3_;
#line 58 "../ebt/Dialog/BtReceiver.vala"
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
#line 58 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp4_);
#line 58 "../ebt/Dialog/BtReceiver.vala"
	overlay = _tmp4_;
#line 59 "../ebt/Dialog/BtReceiver.vala"
	_tmp5_ = overlay;
#line 59 "../ebt/Dialog/BtReceiver.vala"
	_tmp6_ = icon_image;
#line 59 "../ebt/Dialog/BtReceiver.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 60 "../ebt/Dialog/BtReceiver.vala"
	_tmp7_ = overlay;
#line 60 "../ebt/Dialog/BtReceiver.vala"
	_tmp8_ = self->priv->device_image;
#line 60 "../ebt/Dialog/BtReceiver.vala"
	gtk_overlay_add_overlay (_tmp7_, (GtkWidget*) _tmp8_);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_max_width_chars (_tmp9_, 45);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_use_markup (_tmp9_, TRUE);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp9_);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->device_label);
#line 62 "../ebt/Dialog/BtReceiver.vala"
	self->priv->device_label = _tmp9_;
#line 68 "../ebt/Dialog/BtReceiver.vala"
	_tmp10_ = self->priv->device_label;
#line 68 "../ebt/Dialog/BtReceiver.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 68 "../ebt/Dialog/BtReceiver.vala"
	gtk_style_context_add_class (_tmp11_, "primary");
#line 70 "../ebt/Dialog/BtReceiver.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new (NULL);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_max_width_chars (_tmp12_, 45);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_use_markup (_tmp12_, TRUE);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	g_object_set (_tmp12_, "wrap", TRUE, NULL);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_xalign (_tmp12_, (gfloat) 0);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp12_);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->directory_label);
#line 70 "../ebt/Dialog/BtReceiver.vala"
	self->priv->directory_label = _tmp12_;
#line 76 "../ebt/Dialog/BtReceiver.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new (NULL);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_max_width_chars (_tmp13_, 45);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_use_markup (_tmp13_, TRUE);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	g_object_set (_tmp13_, "wrap", TRUE, NULL);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp13_);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->filename_label);
#line 76 "../ebt/Dialog/BtReceiver.vala"
	self->priv->filename_label = _tmp13_;
#line 82 "../ebt/Dialog/BtReceiver.vala"
	_tmp14_ = (GtkLabel*) gtk_label_new (_ ("<b>Transfer rate:</b>"));
#line 82 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_max_width_chars (_tmp14_, 45);
#line 82 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_use_markup (_tmp14_, TRUE);
#line 82 "../ebt/Dialog/BtReceiver.vala"
	g_object_set (_tmp14_, "wrap", TRUE, NULL);
#line 82 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_xalign (_tmp14_, (gfloat) 0);
#line 82 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp14_);
#line 82 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->rate_label);
#line 82 "../ebt/Dialog/BtReceiver.vala"
	self->priv->rate_label = _tmp14_;
#line 88 "../ebt/Dialog/BtReceiver.vala"
	_tmp15_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 88 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
#line 88 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp15_);
#line 88 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->progressbar);
#line 88 "../ebt/Dialog/BtReceiver.vala"
	self->priv->progressbar = _tmp15_;
#line 91 "../ebt/Dialog/BtReceiver.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (NULL);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_max_width_chars (_tmp16_, 45);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, FALSE);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	g_object_set (_tmp16_, "wrap", TRUE, NULL);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	gtk_label_set_xalign (_tmp16_, (gfloat) 0);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp16_);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->progress_label);
#line 91 "../ebt/Dialog/BtReceiver.vala"
	self->priv->progress_label = _tmp16_;
#line 97 "../ebt/Dialog/BtReceiver.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 97 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_set_column_spacing (_tmp17_, 0);
#line 97 "../ebt/Dialog/BtReceiver.vala"
	g_object_set ((GtkWidget*) _tmp17_, "width-request", 450, NULL);
#line 97 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp17_, 15);
#line 97 "../ebt/Dialog/BtReceiver.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 10);
#line 97 "../ebt/Dialog/BtReceiver.vala"
	g_object_ref_sink (_tmp17_);
#line 97 "../ebt/Dialog/BtReceiver.vala"
	message_grid = _tmp17_;
#line 103 "../ebt/Dialog/BtReceiver.vala"
	_tmp18_ = message_grid;
#line 103 "../ebt/Dialog/BtReceiver.vala"
	_tmp19_ = overlay;
#line 103 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 0, 0, 1, 3);
#line 104 "../ebt/Dialog/BtReceiver.vala"
	_tmp20_ = message_grid;
#line 104 "../ebt/Dialog/BtReceiver.vala"
	_tmp21_ = self->priv->device_label;
#line 104 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 1, 0, 1, 1);
#line 105 "../ebt/Dialog/BtReceiver.vala"
	_tmp22_ = message_grid;
#line 105 "../ebt/Dialog/BtReceiver.vala"
	_tmp23_ = self->priv->directory_label;
#line 105 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 1, 1, 1, 1);
#line 106 "../ebt/Dialog/BtReceiver.vala"
	_tmp24_ = message_grid;
#line 106 "../ebt/Dialog/BtReceiver.vala"
	_tmp25_ = self->priv->filename_label;
#line 106 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 1, 2, 1, 1);
#line 107 "../ebt/Dialog/BtReceiver.vala"
	_tmp26_ = message_grid;
#line 107 "../ebt/Dialog/BtReceiver.vala"
	_tmp27_ = self->priv->rate_label;
#line 107 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 1, 3, 1, 1);
#line 108 "../ebt/Dialog/BtReceiver.vala"
	_tmp28_ = message_grid;
#line 108 "../ebt/Dialog/BtReceiver.vala"
	_tmp29_ = self->priv->progressbar;
#line 108 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 1, 4, 1, 1);
#line 109 "../ebt/Dialog/BtReceiver.vala"
	_tmp30_ = message_grid;
#line 109 "../ebt/Dialog/BtReceiver.vala"
	_tmp31_ = self->priv->progress_label;
#line 109 "../ebt/Dialog/BtReceiver.vala"
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 1, 5, 1, 1);
#line 110 "../ebt/Dialog/BtReceiver.vala"
	_tmp32_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 110 "../ebt/Dialog/BtReceiver.vala"
	_tmp33_ = message_grid;
#line 110 "../ebt/Dialog/BtReceiver.vala"
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 112 "../ebt/Dialog/BtReceiver.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Close"), (gint) GTK_RESPONSE_CLOSE);
#line 113 "../ebt/Dialog/BtReceiver.vala"
	_tmp34_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Reject"), (gint) GTK_RESPONSE_ACCEPT);
#line 113 "../ebt/Dialog/BtReceiver.vala"
	_tmp35_ = _g_object_ref0 (_tmp34_);
#line 113 "../ebt/Dialog/BtReceiver.vala"
	suggested_button = _tmp35_;
#line 114 "../ebt/Dialog/BtReceiver.vala"
	_tmp36_ = suggested_button;
#line 114 "../ebt/Dialog/BtReceiver.vala"
	_tmp37_ = gtk_widget_get_style_context (_tmp36_);
#line 114 "../ebt/Dialog/BtReceiver.vala"
	gtk_style_context_add_class (_tmp37_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 115 "../ebt/Dialog/BtReceiver.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __bt_receiver___lambda18__gtk_dialog_response, self, 0);
#line 127 "../ebt/Dialog/BtReceiver.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) __bt_receiver___lambda19__gtk_widget_delete_event, self, 0);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (suggested_button);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (message_grid);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (overlay);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (icon_image);
#line 44 "../ebt/Dialog/BtReceiver.vala"
	return obj;
#line 1811 "BtReceiver.c"
}

static void
bt_receiver_class_init (BtReceiverClass * klass,
                        gpointer klass_data)
{
#line 23 "../ebt/Dialog/BtReceiver.vala"
	bt_receiver_parent_class = g_type_class_peek_parent (klass);
#line 23 "../ebt/Dialog/BtReceiver.vala"
	g_type_class_adjust_private_offset (klass, &BtReceiver_private_offset);
#line 23 "../ebt/Dialog/BtReceiver.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bt_receiver_get_property;
#line 23 "../ebt/Dialog/BtReceiver.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bt_receiver_set_property;
#line 23 "../ebt/Dialog/BtReceiver.vala"
	G_OBJECT_CLASS (klass)->constructor = bt_receiver_constructor;
#line 23 "../ebt/Dialog/BtReceiver.vala"
	G_OBJECT_CLASS (klass)->finalize = bt_receiver_finalize;
#line 23 "../ebt/Dialog/BtReceiver.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BT_RECEIVER_SESSION_PROPERTY, bt_receiver_properties[BT_RECEIVER_SESSION_PROPERTY] = g_param_spec_string ("session", "session", "session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1832 "BtReceiver.c"
}

static void
bt_receiver_instance_init (BtReceiver * self,
                           gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../ebt/Dialog/BtReceiver.vala"
	self->priv = bt_receiver_get_instance_private (self);
#line 33 "../ebt/Dialog/BtReceiver.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../ebt/Dialog/BtReceiver.vala"
	self->priv->path_folder = _tmp0_;
#line 35 "../ebt/Dialog/BtReceiver.vala"
	self->priv->start_time = 0;
#line 36 "../ebt/Dialog/BtReceiver.vala"
	self->priv->total_size = (guint64) 0;
#line 1850 "BtReceiver.c"
}

static void
bt_receiver_finalize (GObject * obj)
{
	BtReceiver * self;
#line 23 "../ebt/Dialog/BtReceiver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BT_RECEIVER, BtReceiver);
#line 24 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->transfer);
#line 25 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->progressbar);
#line 26 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->device_label);
#line 27 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->directory_label);
#line 28 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->progress_label);
#line 29 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->filename_label);
#line 30 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->rate_label);
#line 31 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->device_image);
#line 32 "../ebt/Dialog/BtReceiver.vala"
	_g_object_unref0 (self->priv->notification);
#line 33 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (self->priv->path_folder);
#line 34 "../ebt/Dialog/BtReceiver.vala"
	_g_free0 (self->priv->_session);
#line 23 "../ebt/Dialog/BtReceiver.vala"
	G_OBJECT_CLASS (bt_receiver_parent_class)->finalize (obj);
#line 1883 "BtReceiver.c"
}

static GType
bt_receiver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BtReceiverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bt_receiver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BtReceiver), 0, (GInstanceInitFunc) bt_receiver_instance_init, NULL };
	GType bt_receiver_type_id;
	bt_receiver_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "BtReceiver", &g_define_type_info, 0);
	BtReceiver_private_offset = g_type_add_instance_private (bt_receiver_type_id, sizeof (BtReceiverPrivate));
	return bt_receiver_type_id;
}

GType
bt_receiver_get_type (void)
{
	static volatile gsize bt_receiver_type_id__once = 0;
	if (g_once_init_enter (&bt_receiver_type_id__once)) {
		GType bt_receiver_type_id;
		bt_receiver_type_id = bt_receiver_get_type_once ();
		g_once_init_leave (&bt_receiver_type_id__once, bt_receiver_type_id);
	}
	return bt_receiver_type_id__once;
}

static void
_vala_bt_receiver_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	BtReceiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BT_RECEIVER, BtReceiver);
#line 23 "../ebt/Dialog/BtReceiver.vala"
	switch (property_id) {
#line 23 "../ebt/Dialog/BtReceiver.vala"
		case BT_RECEIVER_SESSION_PROPERTY:
#line 23 "../ebt/Dialog/BtReceiver.vala"
		g_value_set_string (value, bt_receiver_get_session (self));
#line 23 "../ebt/Dialog/BtReceiver.vala"
		break;
#line 1924 "BtReceiver.c"
		default:
#line 23 "../ebt/Dialog/BtReceiver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../ebt/Dialog/BtReceiver.vala"
		break;
#line 1930 "BtReceiver.c"
	}
}

static void
_vala_bt_receiver_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	BtReceiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BT_RECEIVER, BtReceiver);
#line 23 "../ebt/Dialog/BtReceiver.vala"
	switch (property_id) {
#line 23 "../ebt/Dialog/BtReceiver.vala"
		case BT_RECEIVER_SESSION_PROPERTY:
#line 23 "../ebt/Dialog/BtReceiver.vala"
		bt_receiver_set_session (self, g_value_get_string (value));
#line 23 "../ebt/Dialog/BtReceiver.vala"
		break;
#line 1950 "BtReceiver.c"
		default:
#line 23 "../ebt/Dialog/BtReceiver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../ebt/Dialog/BtReceiver.vala"
		break;
#line 1956 "BtReceiver.c"
	}
}

