/* Indicator.c generated by valac 0.56.14, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*-
 * Copyright (c) 2015-2023 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "bluetooth.h"
#include <glib.h>
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

enum  {
	BLUETOOTH_INDICATOR_INDICATOR_0_PROPERTY,
	BLUETOOTH_INDICATOR_INDICATOR_IS_IN_SESSION_PROPERTY,
	BLUETOOTH_INDICATOR_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* bluetooth_indicator_indicator_properties[BLUETOOTH_INDICATOR_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BluetoothIndicatorIndicatorPrivate {
	gboolean _is_in_session;
	BluetoothIndicatorWidgetsPopoverWidget* popover_widget;
	BluetoothIndicatorWidgetsDisplayWidget* dynamic_icon;
	BluetoothIndicatorServicesObjectManager* object_manager;
	BluetoothIndicatorServicesObexManager* obex_manager;
};

static gint BluetoothIndicatorIndicator_private_offset;
static gpointer bluetooth_indicator_indicator_parent_class = NULL;

static GtkWidget* bluetooth_indicator_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* bluetooth_indicator_indicator_real_get_widget (WingpanelIndicator* base);
static void bluetooth_indicator_indicator_real_opened (WingpanelIndicator* base);
static void bluetooth_indicator_indicator_real_closed (WingpanelIndicator* base);
static GObject * bluetooth_indicator_indicator_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static void _bluetooth_indicator_indicator___lambda33_ (BluetoothIndicatorIndicator* self);
static void __bluetooth_indicator_indicator___lambda33__g_object_notify (GObject* _sender,
                                                                  GParamSpec* pspec,
                                                                  gpointer self);
static void bluetooth_indicator_indicator_finalize (GObject * obj);
static GType bluetooth_indicator_indicator_get_type_once (void);
static void _vala_bluetooth_indicator_indicator_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_bluetooth_indicator_indicator_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
bluetooth_indicator_indicator_get_instance_private (BluetoothIndicatorIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothIndicatorIndicator_private_offset);
}

BluetoothIndicatorIndicator*
bluetooth_indicator_indicator_construct (GType object_type,
                                         gboolean is_in_session)
{
	BluetoothIndicatorIndicator * self = NULL;
#line 27 "../src/Indicator.vala"
	self = (BluetoothIndicatorIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_BLUETOOTH, "is-in-session", is_in_session, NULL);
#line 26 "../src/Indicator.vala"
	return self;
#line 86 "Indicator.c"
}

BluetoothIndicatorIndicator*
bluetooth_indicator_indicator_new (gboolean is_in_session)
{
#line 26 "../src/Indicator.vala"
	return bluetooth_indicator_indicator_construct (BLUETOOTH_INDICATOR_TYPE_INDICATOR, is_in_session);
#line 94 "Indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 102 "Indicator.c"
}

static GtkWidget*
bluetooth_indicator_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	BluetoothIndicatorIndicator * self;
	BluetoothIndicatorWidgetsDisplayWidget* _tmp0_;
	BluetoothIndicatorWidgetsDisplayWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 51 "../src/Indicator.vala"
	self = (BluetoothIndicatorIndicator*) base;
#line 52 "../src/Indicator.vala"
	_tmp0_ = self->priv->dynamic_icon;
#line 52 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 119 "Indicator.c"
		BluetoothIndicatorServicesObjectManager* _tmp1_;
		BluetoothIndicatorWidgetsDisplayWidget* _tmp2_;
#line 53 "../src/Indicator.vala"
		_tmp1_ = self->priv->object_manager;
#line 53 "../src/Indicator.vala"
		_tmp2_ = bluetooth_indicator_widgets_display_widget_new (_tmp1_);
#line 53 "../src/Indicator.vala"
		g_object_ref_sink (_tmp2_);
#line 53 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->dynamic_icon);
#line 53 "../src/Indicator.vala"
		self->priv->dynamic_icon = _tmp2_;
#line 132 "Indicator.c"
	}
#line 56 "../src/Indicator.vala"
	_tmp3_ = self->priv->dynamic_icon;
#line 56 "../src/Indicator.vala"
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _tmp3_);
#line 56 "../src/Indicator.vala"
	result = _tmp4_;
#line 56 "../src/Indicator.vala"
	return result;
#line 142 "Indicator.c"
}

static GtkWidget*
bluetooth_indicator_indicator_real_get_widget (WingpanelIndicator* base)
{
	BluetoothIndicatorIndicator * self;
	BluetoothIndicatorWidgetsPopoverWidget* _tmp0_;
	BluetoothIndicatorWidgetsPopoverWidget* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* result;
#line 59 "../src/Indicator.vala"
	self = (BluetoothIndicatorIndicator*) base;
#line 60 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 60 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 159 "Indicator.c"
		BluetoothIndicatorServicesObjectManager* _tmp1_;
		BluetoothIndicatorServicesObexManager* _tmp2_;
		gboolean _tmp3_;
		BluetoothIndicatorWidgetsPopoverWidget* _tmp4_;
#line 61 "../src/Indicator.vala"
		_tmp1_ = self->priv->object_manager;
#line 61 "../src/Indicator.vala"
		_tmp2_ = self->priv->obex_manager;
#line 61 "../src/Indicator.vala"
		_tmp3_ = self->priv->_is_in_session;
#line 61 "../src/Indicator.vala"
		_tmp4_ = bluetooth_indicator_widgets_popover_widget_new (_tmp1_, _tmp2_, _tmp3_);
#line 61 "../src/Indicator.vala"
		g_object_ref_sink (_tmp4_);
#line 61 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->popover_widget);
#line 61 "../src/Indicator.vala"
		self->priv->popover_widget = _tmp4_;
#line 178 "Indicator.c"
	}
#line 64 "../src/Indicator.vala"
	_tmp5_ = self->priv->popover_widget;
#line 64 "../src/Indicator.vala"
	_tmp6_ = _g_object_ref0 ((GtkWidget*) _tmp5_);
#line 64 "../src/Indicator.vala"
	result = _tmp6_;
#line 64 "../src/Indicator.vala"
	return result;
#line 188 "Indicator.c"
}

static void
bluetooth_indicator_indicator_real_opened (WingpanelIndicator* base)
{
	BluetoothIndicatorIndicator * self;
#line 68 "../src/Indicator.vala"
	self = (BluetoothIndicatorIndicator*) base;
#line 197 "Indicator.c"
}

static void
bluetooth_indicator_indicator_real_closed (WingpanelIndicator* base)
{
	BluetoothIndicatorIndicator * self;
#line 71 "../src/Indicator.vala"
	self = (BluetoothIndicatorIndicator*) base;
#line 206 "Indicator.c"
}

gboolean
bluetooth_indicator_indicator_get_is_in_session (BluetoothIndicatorIndicator* self)
{
	gboolean result;
#line 19 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19 "../src/Indicator.vala"
	result = self->priv->_is_in_session;
#line 19 "../src/Indicator.vala"
	return result;
#line 219 "Indicator.c"
}

static void
bluetooth_indicator_indicator_set_is_in_session (BluetoothIndicatorIndicator* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 19 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Indicator.vala"
	old_value = bluetooth_indicator_indicator_get_is_in_session (self);
#line 19 "../src/Indicator.vala"
	if (old_value != value) {
#line 19 "../src/Indicator.vala"
		self->priv->_is_in_session = value;
#line 19 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_indicator_indicator_properties[BLUETOOTH_INDICATOR_INDICATOR_IS_IN_SESSION_PROPERTY]);
#line 237 "Indicator.c"
	}
}

static void
_bluetooth_indicator_indicator___lambda33_ (BluetoothIndicatorIndicator* self)
{
	BluetoothIndicatorServicesObjectManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 45 "../src/Indicator.vala"
	_tmp0_ = self->priv->object_manager;
#line 45 "../src/Indicator.vala"
	_tmp1_ = bluetooth_indicator_services_object_manager_get_has_object (_tmp0_);
#line 45 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/Indicator.vala"
	if (_tmp2_) {
#line 255 "Indicator.c"
		BluetoothIndicatorServicesObjectManager* _tmp3_;
#line 46 "../src/Indicator.vala"
		_tmp3_ = self->priv->object_manager;
#line 46 "../src/Indicator.vala"
		bluetooth_indicator_services_object_manager_set_state_from_settings (_tmp3_, NULL, NULL);
#line 261 "Indicator.c"
	}
}

static void
__bluetooth_indicator_indicator___lambda33__g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self)
{
#line 44 "../src/Indicator.vala"
	_bluetooth_indicator_indicator___lambda33_ ((BluetoothIndicatorIndicator*) self);
#line 272 "Indicator.c"
}

static GObject *
bluetooth_indicator_indicator_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothIndicatorIndicator * self;
	BluetoothIndicatorServicesObjectManager* _tmp0_;
	BluetoothIndicatorServicesObjectManager* _tmp1_;
	BluetoothIndicatorServicesObexManager* _tmp2_;
	BluetoothIndicatorServicesObjectManager* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	BluetoothIndicatorServicesObjectManager* _tmp7_;
#line 33 "../src/Indicator.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_indicator_indicator_parent_class);
#line 33 "../src/Indicator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 33 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_INDICATOR_TYPE_INDICATOR, BluetoothIndicatorIndicator);
#line 34 "../src/Indicator.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 35 "../src/Indicator.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 37 "../src/Indicator.vala"
	_tmp0_ = bluetooth_indicator_services_object_manager_new ();
#line 37 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->object_manager);
#line 37 "../src/Indicator.vala"
	self->priv->object_manager = _tmp0_;
#line 38 "../src/Indicator.vala"
	_tmp1_ = self->priv->object_manager;
#line 38 "../src/Indicator.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp1_, "has-object", (GObject*) self, "visible", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 39 "../src/Indicator.vala"
	_tmp2_ = bluetooth_indicator_services_obex_manager_new ();
#line 39 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->obex_manager);
#line 39 "../src/Indicator.vala"
	self->priv->obex_manager = _tmp2_;
#line 40 "../src/Indicator.vala"
	_tmp3_ = self->priv->object_manager;
#line 40 "../src/Indicator.vala"
	_tmp4_ = bluetooth_indicator_services_object_manager_get_has_object (_tmp3_);
#line 40 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/Indicator.vala"
	if (_tmp5_) {
#line 324 "Indicator.c"
		BluetoothIndicatorServicesObjectManager* _tmp6_;
#line 41 "../src/Indicator.vala"
		_tmp6_ = self->priv->object_manager;
#line 41 "../src/Indicator.vala"
		bluetooth_indicator_services_object_manager_set_state_from_settings (_tmp6_, NULL, NULL);
#line 330 "Indicator.c"
	}
#line 44 "../src/Indicator.vala"
	_tmp7_ = self->priv->object_manager;
#line 44 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::has-object", (GCallback) __bluetooth_indicator_indicator___lambda33__g_object_notify, self, 0);
#line 33 "../src/Indicator.vala"
	return obj;
#line 338 "Indicator.c"
}

static void
bluetooth_indicator_indicator_class_init (BluetoothIndicatorIndicatorClass * klass,
                                          gpointer klass_data)
{
#line 18 "../src/Indicator.vala"
	bluetooth_indicator_indicator_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothIndicatorIndicator_private_offset);
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) bluetooth_indicator_indicator_real_get_display_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) bluetooth_indicator_indicator_real_get_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) bluetooth_indicator_indicator_real_opened;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) bluetooth_indicator_indicator_real_closed;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_indicator_indicator_get_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_indicator_indicator_set_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_indicator_indicator_constructor;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_indicator_indicator_finalize;
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_INDICATOR_INDICATOR_IS_IN_SESSION_PROPERTY, bluetooth_indicator_indicator_properties[BLUETOOTH_INDICATOR_INDICATOR_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 367 "Indicator.c"
}

static void
bluetooth_indicator_indicator_instance_init (BluetoothIndicatorIndicator * self,
                                             gpointer klass)
{
#line 18 "../src/Indicator.vala"
	self->priv = bluetooth_indicator_indicator_get_instance_private (self);
#line 19 "../src/Indicator.vala"
	self->priv->_is_in_session = FALSE;
#line 378 "Indicator.c"
}

static void
bluetooth_indicator_indicator_finalize (GObject * obj)
{
	BluetoothIndicatorIndicator * self;
#line 18 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_INDICATOR_TYPE_INDICATOR, BluetoothIndicatorIndicator);
#line 21 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->popover_widget);
#line 22 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->dynamic_icon);
#line 23 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->object_manager);
#line 24 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->obex_manager);
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (bluetooth_indicator_indicator_parent_class)->finalize (obj);
#line 397 "Indicator.c"
}

static GType
bluetooth_indicator_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothIndicatorIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_indicator_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothIndicatorIndicator), 0, (GInstanceInitFunc) bluetooth_indicator_indicator_instance_init, NULL };
	GType bluetooth_indicator_indicator_type_id;
	bluetooth_indicator_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "BluetoothIndicatorIndicator", &g_define_type_info, 0);
	BluetoothIndicatorIndicator_private_offset = g_type_add_instance_private (bluetooth_indicator_indicator_type_id, sizeof (BluetoothIndicatorIndicatorPrivate));
	return bluetooth_indicator_indicator_type_id;
}

GType
bluetooth_indicator_indicator_get_type (void)
{
	static volatile gsize bluetooth_indicator_indicator_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_indicator_indicator_type_id__once)) {
		GType bluetooth_indicator_indicator_type_id;
		bluetooth_indicator_indicator_type_id = bluetooth_indicator_indicator_get_type_once ();
		g_once_init_leave (&bluetooth_indicator_indicator_type_id__once, bluetooth_indicator_indicator_type_id);
	}
	return bluetooth_indicator_indicator_type_id__once;
}

static void
_vala_bluetooth_indicator_indicator_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	BluetoothIndicatorIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_INDICATOR_TYPE_INDICATOR, BluetoothIndicatorIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case BLUETOOTH_INDICATOR_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_boolean (value, bluetooth_indicator_indicator_get_is_in_session (self));
#line 18 "../src/Indicator.vala"
		break;
#line 438 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 444 "Indicator.c"
	}
}

static void
_vala_bluetooth_indicator_indicator_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	BluetoothIndicatorIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_INDICATOR_TYPE_INDICATOR, BluetoothIndicatorIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case BLUETOOTH_INDICATOR_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 18 "../src/Indicator.vala"
		bluetooth_indicator_indicator_set_is_in_session (self, g_value_get_boolean (value));
#line 18 "../src/Indicator.vala"
		break;
#line 464 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 470 "Indicator.c"
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	BluetoothIndicatorIndicator* indicator = NULL;
	BluetoothIndicatorIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 75 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 76 "../src/Indicator.vala"
	g_debug ("Indicator.vala:76: Activating Bluetooth Indicator");
#line 77 "../src/Indicator.vala"
	_tmp0_ = bluetooth_indicator_indicator_new (server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION);
#line 77 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 79 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 79 "../src/Indicator.vala"
	return result;
#line 493 "Indicator.c"
}

