/* Device.c generated by valac 0.56.14, the Vala compiler
 * generated from Device.vala, do not modify */

/*-
 * Copyright (c) 2015-2023 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "bluetooth.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <pango/pango.h>

#define BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEFAULT_ICON "bluetooth"
#define BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_AGENT "org.bluez.obex.Agent1"
#define BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_PATH "/org/bluez/obex/elementary"

enum  {
	BLUETOOTH_INDICATOR_WIDGETS_DEVICE_0_PROPERTY,
	BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEVICE_PROPERTY,
	BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_MANAGER_PROPERTY,
	BLUETOOTH_INDICATOR_WIDGETS_DEVICE_NUM_PROPERTIES
};
static GParamSpec* bluetooth_indicator_widgets_device_properties[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothIndicatorWidgetsDeviceToggleDeviceData BluetoothIndicatorWidgetsDeviceToggleDeviceData;
enum  {
	BLUETOOTH_INDICATOR_WIDGETS_DEVICE_SHOW_DEVICE_SIGNAL,
	BLUETOOTH_INDICATOR_WIDGETS_DEVICE_NUM_SIGNALS
};
static guint bluetooth_indicator_widgets_device_signals[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_NUM_SIGNALS] = {0};

struct _BluetoothIndicatorWidgetsDevicePrivate {
	BluetoothIndicatorServicesDevice* _device;
	BluetoothIndicatorServicesObexManager* _obex_manager;
	GtkLabel* status_label;
	GtkLabel* name_label;
	GtkLabel* progress_label;
	GtkLabel* file_label;
	GtkImage* icon_image;
	GtkImage* status_image;
	GtkSpinner* spinner;
	GtkRevealer* progress_revealer;
	GtkProgressBar* progressbar;
};

struct _BluetoothIndicatorWidgetsDeviceToggleDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothIndicatorWidgetsDevice* self;
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GDBusConnection* connection;
	GDBusConnection* _tmp3_;
	GDBusConnection* _tmp4_;
	BluetoothIndicatorServicesObexTransfer* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GError* e;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GtkSpinner* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkSpinner* _tmp18_;
	GtkImage* _tmp19_;
	BluetoothIndicatorServicesDevice* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GtkLabel* _tmp23_;
	BluetoothIndicatorServicesDevice* _tmp24_;
	GtkLabel* _tmp25_;
	BluetoothIndicatorServicesDevice* _tmp26_;
	GError* _vala1_e;
	GError* _tmp27_;
	const gchar* _tmp28_;
	GtkLabel* _tmp29_;
	GtkImage* _tmp30_;
	GtkSpinner* _tmp31_;
	GError* _inner_error0_;
};

static gint BluetoothIndicatorWidgetsDevice_private_offset;
static gpointer bluetooth_indicator_widgets_device_parent_class = NULL;

static void bluetooth_indicator_widgets_device_on_obex_transfer_removed (BluetoothIndicatorWidgetsDevice* self,
                                                                  BluetoothIndicatorServicesObexTransfer* transfer);
static void bluetooth_indicator_widgets_device_on_obex_transfer_active (BluetoothIndicatorWidgetsDevice* self,
                                                                 const gchar* address);
static void bluetooth_indicator_widgets_device_update_transfer_progress (BluetoothIndicatorWidgetsDevice* self);
static void bluetooth_indicator_widgets_device_on_obex_transfer_added (BluetoothIndicatorWidgetsDevice* self,
                                                                const gchar* address,
                                                                BluetoothIndicatorServicesObexTransfer* transfer);
static gboolean bluetooth_indicator_widgets_device_bt_status (BluetoothIndicatorWidgetsDevice* self,
                                                       const gchar* filename);
static void bluetooth_indicator_widgets_device_toggle_device_data_free (gpointer _data);
static gboolean bluetooth_indicator_widgets_device_toggle_device_co (BluetoothIndicatorWidgetsDeviceToggleDeviceData* _data_);
static void bluetooth_indicator_widgets_device_toggle_device_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void bluetooth_indicator_widgets_device_update_status (BluetoothIndicatorWidgetsDevice* self);
static GObject * bluetooth_indicator_widgets_device_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties);
static void _bluetooth_indicator_widgets_device_on_obex_transfer_added_bluetooth_indicator_services_obex_manager_transfer_added (BluetoothIndicatorServicesObexManager* _sender,
                                                                                                                          const gchar* address,
                                                                                                                          BluetoothIndicatorServicesObexTransfer* transfer,
                                                                                                                          gpointer self);
static void _bluetooth_indicator_widgets_device_on_obex_transfer_removed_bluetooth_indicator_services_obex_manager_transfer_removed (BluetoothIndicatorServicesObexManager* _sender,
                                                                                                                              BluetoothIndicatorServicesObexTransfer* transfer,
                                                                                                                              gpointer self);
static void _bluetooth_indicator_widgets_device_on_obex_transfer_active_bluetooth_indicator_services_obex_manager_transfer_active (BluetoothIndicatorServicesObexManager* _sender,
                                                                                                                            const gchar* address,
                                                                                                                            gpointer self);
static void _bluetooth_indicator_widgets_device_update_status_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                                          GVariant* changed_properties,
                                                                                          gchar** invalidated_properties,
                                                                                          gpointer self);
static void _bluetooth_indicator_widgets_device___lambda22_ (BluetoothIndicatorWidgetsDevice* self,
                                                      BluetoothIndicatorServicesObexTransfer* transfer,
                                                      const gchar* address);
static void __bluetooth_indicator_widgets_device___lambda22__gh_func (gconstpointer key,
                                                               gconstpointer value,
                                                               gpointer self);
static void bluetooth_indicator_widgets_device_finalize (GObject * obj);
static GType bluetooth_indicator_widgets_device_get_type_once (void);
static void _vala_bluetooth_indicator_widgets_device_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_bluetooth_indicator_widgets_device_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);

static inline gpointer
bluetooth_indicator_widgets_device_get_instance_private (BluetoothIndicatorWidgetsDevice* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothIndicatorWidgetsDevice_private_offset);
}

BluetoothIndicatorWidgetsDevice*
bluetooth_indicator_widgets_device_construct (GType object_type,
                                              BluetoothIndicatorServicesDevice* device,
                                              BluetoothIndicatorServicesObexManager* obex_manager)
{
	BluetoothIndicatorWidgetsDevice * self = NULL;
#line 36 "../src/Widgets/Device.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 36 "../src/Widgets/Device.vala"
	g_return_val_if_fail (obex_manager != NULL, NULL);
#line 37 "../src/Widgets/Device.vala"
	self = (BluetoothIndicatorWidgetsDevice*) g_object_new (object_type, "device", device, "obex-manager", obex_manager, NULL);
#line 36 "../src/Widgets/Device.vala"
	return self;
#line 187 "Device.c"
}

BluetoothIndicatorWidgetsDevice*
bluetooth_indicator_widgets_device_new (BluetoothIndicatorServicesDevice* device,
                                        BluetoothIndicatorServicesObexManager* obex_manager)
{
#line 36 "../src/Widgets/Device.vala"
	return bluetooth_indicator_widgets_device_construct (BLUETOOTH_INDICATOR_WIDGETS_TYPE_DEVICE, device, obex_manager);
#line 196 "Device.c"
}

static void
bluetooth_indicator_widgets_device_on_obex_transfer_removed (BluetoothIndicatorWidgetsDevice* self,
                                                             BluetoothIndicatorServicesObexTransfer* transfer)
{
#line 136 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Widgets/Device.vala"
	g_return_if_fail (transfer != NULL);
#line 137 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_hide_action (self);
#line 209 "Device.c"
}

static void
bluetooth_indicator_widgets_device_on_obex_transfer_active (BluetoothIndicatorWidgetsDevice* self,
                                                            const gchar* address)
{
	BluetoothIndicatorServicesDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 140 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/Widgets/Device.vala"
	g_return_if_fail (address != NULL);
#line 141 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->_device;
#line 141 "../src/Widgets/Device.vala"
	_tmp1_ = bluetooth_indicator_services_device_get_address (_tmp0_);
#line 141 "../src/Widgets/Device.vala"
	_tmp2_ = _tmp1_;
#line 141 "../src/Widgets/Device.vala"
	_tmp3_ = _tmp2_;
#line 141 "../src/Widgets/Device.vala"
	_tmp4_ = g_strcmp0 (address, _tmp3_) == 0;
#line 141 "../src/Widgets/Device.vala"
	_g_free0 (_tmp3_);
#line 141 "../src/Widgets/Device.vala"
	if (_tmp4_) {
#line 142 "../src/Widgets/Device.vala"
		bluetooth_indicator_widgets_device_update_transfer_progress (self);
#line 241 "Device.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 148 "../src/Widgets/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 250 "Device.c"
}

static void
bluetooth_indicator_widgets_device_on_obex_transfer_added (BluetoothIndicatorWidgetsDevice* self,
                                                           const gchar* address,
                                                           BluetoothIndicatorServicesObexTransfer* transfer)
{
	BluetoothIndicatorServicesDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 146 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/Widgets/Device.vala"
	g_return_if_fail (address != NULL);
#line 146 "../src/Widgets/Device.vala"
	g_return_if_fail (transfer != NULL);
#line 147 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->_device;
#line 147 "../src/Widgets/Device.vala"
	_tmp1_ = bluetooth_indicator_services_device_get_address (_tmp0_);
#line 147 "../src/Widgets/Device.vala"
	_tmp2_ = _tmp1_;
#line 147 "../src/Widgets/Device.vala"
	_tmp3_ = _tmp2_;
#line 147 "../src/Widgets/Device.vala"
	_tmp4_ = g_strcmp0 (address, _tmp3_) == 0;
#line 147 "../src/Widgets/Device.vala"
	_g_free0 (_tmp3_);
#line 147 "../src/Widgets/Device.vala"
	if (_tmp4_) {
#line 283 "Device.c"
		BluetoothIndicatorServicesObexTransfer* _tmp5_;
#line 148 "../src/Widgets/Device.vala"
		_tmp5_ = _g_object_ref0 (transfer);
#line 148 "../src/Widgets/Device.vala"
		_g_object_unref0 (self->transfer);
#line 148 "../src/Widgets/Device.vala"
		self->transfer = _tmp5_;
#line 291 "Device.c"
	}
}

static void
bluetooth_indicator_widgets_device_update_transfer_progress (BluetoothIndicatorWidgetsDevice* self)
{
	BluetoothIndicatorServicesObexTransfer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 153 "../src/Widgets/Device.vala"
	static GQuark _tmp4_label0 = 0;
#line 153 "../src/Widgets/Device.vala"
	static GQuark _tmp4_label1 = 0;
#line 153 "../src/Widgets/Device.vala"
	static GQuark _tmp4_label2 = 0;
#line 153 "../src/Widgets/Device.vala"
	static GQuark _tmp4_label3 = 0;
#line 152 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Widgets/Device.vala"
	_tmp0_ = self->transfer;
#line 153 "../src/Widgets/Device.vala"
	_tmp1_ = bluetooth_indicator_services_obex_transfer_get_status (_tmp0_);
#line 153 "../src/Widgets/Device.vala"
	_tmp2_ = _tmp1_;
#line 153 "../src/Widgets/Device.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/Widgets/Device.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 153 "../src/Widgets/Device.vala"
	g_free (_tmp3_);
#line 153 "../src/Widgets/Device.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("error")))) {
#line 153 "../src/Widgets/Device.vala"
		switch (0) {
#line 329 "Device.c"
			default:
			{
#line 155 "../src/Widgets/Device.vala"
				bluetooth_indicator_widgets_device_hide_action (self);
#line 156 "../src/Widgets/Device.vala"
				break;
#line 336 "Device.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("queued")))) {
#line 153 "../src/Widgets/Device.vala"
		switch (0) {
#line 342 "Device.c"
			default:
			{
#line 158 "../src/Widgets/Device.vala"
				bluetooth_indicator_widgets_device_hide_action (self);
#line 159 "../src/Widgets/Device.vala"
				break;
#line 349 "Device.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("active")))) {
#line 153 "../src/Widgets/Device.vala"
		switch (0) {
#line 355 "Device.c"
			default:
			{
				GtkProgressBar* _tmp6_;
				BluetoothIndicatorServicesObexTransfer* _tmp7_;
				guint64 _tmp8_;
				guint64 _tmp9_;
				BluetoothIndicatorServicesObexTransfer* _tmp10_;
				guint64 _tmp11_;
				guint64 _tmp12_;
				GtkRevealer* _tmp13_;
				gchar* name = NULL;
				BluetoothIndicatorServicesObexTransfer* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* filename = NULL;
				BluetoothIndicatorServicesObexTransfer* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
#line 161 "../src/Widgets/Device.vala"
				_tmp6_ = self->priv->progressbar;
#line 161 "../src/Widgets/Device.vala"
				_tmp7_ = self->transfer;
#line 161 "../src/Widgets/Device.vala"
				_tmp8_ = bluetooth_indicator_services_obex_transfer_get_transferred (_tmp7_);
#line 161 "../src/Widgets/Device.vala"
				_tmp9_ = _tmp8_;
#line 161 "../src/Widgets/Device.vala"
				_tmp10_ = self->transfer;
#line 161 "../src/Widgets/Device.vala"
				_tmp11_ = bluetooth_indicator_services_obex_transfer_get_size (_tmp10_);
#line 161 "../src/Widgets/Device.vala"
				_tmp12_ = _tmp11_;
#line 161 "../src/Widgets/Device.vala"
				gtk_progress_bar_set_fraction (_tmp6_, ((gdouble) _tmp9_) / ((gdouble) _tmp12_));
#line 162 "../src/Widgets/Device.vala"
				_tmp13_ = self->priv->progress_revealer;
#line 162 "../src/Widgets/Device.vala"
				gtk_revealer_set_reveal_child (_tmp13_, TRUE);
#line 163 "../src/Widgets/Device.vala"
				_tmp14_ = self->transfer;
#line 163 "../src/Widgets/Device.vala"
				_tmp15_ = bluetooth_indicator_services_obex_transfer_get_name (_tmp14_);
#line 163 "../src/Widgets/Device.vala"
				_tmp16_ = _tmp15_;
#line 163 "../src/Widgets/Device.vala"
				name = _tmp16_;
#line 164 "../src/Widgets/Device.vala"
				_tmp17_ = name;
#line 164 "../src/Widgets/Device.vala"
				if (_tmp17_ != NULL) {
#line 408 "Device.c"
					GtkLabel* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 165 "../src/Widgets/Device.vala"
					_tmp18_ = self->priv->file_label;
#line 165 "../src/Widgets/Device.vala"
					_tmp19_ = name;
#line 165 "../src/Widgets/Device.vala"
					_tmp20_ = g_markup_escape_text (_tmp19_, (gssize) -1);
#line 165 "../src/Widgets/Device.vala"
					_tmp21_ = _tmp20_;
#line 165 "../src/Widgets/Device.vala"
					_tmp22_ = g_strdup_printf (_ ("<b>Filename</b>: %s"), _tmp21_);
#line 165 "../src/Widgets/Device.vala"
					_tmp23_ = _tmp22_;
#line 165 "../src/Widgets/Device.vala"
					gtk_label_set_markup (_tmp18_, _tmp23_);
#line 165 "../src/Widgets/Device.vala"
					_g_free0 (_tmp23_);
#line 165 "../src/Widgets/Device.vala"
					_g_free0 (_tmp21_);
#line 433 "Device.c"
				}
#line 167 "../src/Widgets/Device.vala"
				_tmp24_ = self->transfer;
#line 167 "../src/Widgets/Device.vala"
				_tmp25_ = bluetooth_indicator_services_obex_transfer_get_filename (_tmp24_);
#line 167 "../src/Widgets/Device.vala"
				_tmp26_ = _tmp25_;
#line 167 "../src/Widgets/Device.vala"
				filename = _tmp26_;
#line 168 "../src/Widgets/Device.vala"
				_tmp27_ = filename;
#line 168 "../src/Widgets/Device.vala"
				if (_tmp27_ != NULL) {
#line 447 "Device.c"
					const gchar* _tmp28_;
#line 169 "../src/Widgets/Device.vala"
					_tmp28_ = filename;
#line 169 "../src/Widgets/Device.vala"
					if (bluetooth_indicator_widgets_device_bt_status (self, _tmp28_)) {
#line 453 "Device.c"
						GtkLabel* _tmp29_;
						BluetoothIndicatorServicesObexTransfer* _tmp30_;
						guint64 _tmp31_;
						guint64 _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						BluetoothIndicatorServicesObexTransfer* _tmp35_;
						guint64 _tmp36_;
						guint64 _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
#line 170 "../src/Widgets/Device.vala"
						_tmp29_ = self->priv->progress_label;
#line 170 "../src/Widgets/Device.vala"
						_tmp30_ = self->transfer;
#line 170 "../src/Widgets/Device.vala"
						_tmp31_ = bluetooth_indicator_services_obex_transfer_get_transferred (_tmp30_);
#line 170 "../src/Widgets/Device.vala"
						_tmp32_ = _tmp31_;
#line 170 "../src/Widgets/Device.vala"
						_tmp33_ = g_format_size_full (_tmp32_, G_FORMAT_SIZE_DEFAULT);
#line 170 "../src/Widgets/Device.vala"
						_tmp34_ = _tmp33_;
#line 170 "../src/Widgets/Device.vala"
						_tmp35_ = self->transfer;
#line 170 "../src/Widgets/Device.vala"
						_tmp36_ = bluetooth_indicator_services_obex_transfer_get_size (_tmp35_);
#line 170 "../src/Widgets/Device.vala"
						_tmp37_ = _tmp36_;
#line 170 "../src/Widgets/Device.vala"
						_tmp38_ = g_format_size_full (_tmp37_, G_FORMAT_SIZE_DEFAULT);
#line 170 "../src/Widgets/Device.vala"
						_tmp39_ = _tmp38_;
#line 170 "../src/Widgets/Device.vala"
						_tmp40_ = g_strdup_printf (_ ("Receiving… %s of %s"), _tmp34_, _tmp39_);
#line 170 "../src/Widgets/Device.vala"
						_tmp41_ = _tmp40_;
#line 170 "../src/Widgets/Device.vala"
						gtk_label_set_label (_tmp29_, _tmp41_);
#line 170 "../src/Widgets/Device.vala"
						_g_free0 (_tmp41_);
#line 170 "../src/Widgets/Device.vala"
						_g_free0 (_tmp39_);
#line 170 "../src/Widgets/Device.vala"
						_g_free0 (_tmp34_);
#line 501 "Device.c"
					} else {
						GtkLabel* _tmp42_;
						BluetoothIndicatorServicesObexTransfer* _tmp43_;
						guint64 _tmp44_;
						guint64 _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						BluetoothIndicatorServicesObexTransfer* _tmp48_;
						guint64 _tmp49_;
						guint64 _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
#line 174 "../src/Widgets/Device.vala"
						_tmp42_ = self->priv->progress_label;
#line 174 "../src/Widgets/Device.vala"
						_tmp43_ = self->transfer;
#line 174 "../src/Widgets/Device.vala"
						_tmp44_ = bluetooth_indicator_services_obex_transfer_get_transferred (_tmp43_);
#line 174 "../src/Widgets/Device.vala"
						_tmp45_ = _tmp44_;
#line 174 "../src/Widgets/Device.vala"
						_tmp46_ = g_format_size_full (_tmp45_, G_FORMAT_SIZE_DEFAULT);
#line 174 "../src/Widgets/Device.vala"
						_tmp47_ = _tmp46_;
#line 174 "../src/Widgets/Device.vala"
						_tmp48_ = self->transfer;
#line 174 "../src/Widgets/Device.vala"
						_tmp49_ = bluetooth_indicator_services_obex_transfer_get_size (_tmp48_);
#line 174 "../src/Widgets/Device.vala"
						_tmp50_ = _tmp49_;
#line 174 "../src/Widgets/Device.vala"
						_tmp51_ = g_format_size_full (_tmp50_, G_FORMAT_SIZE_DEFAULT);
#line 174 "../src/Widgets/Device.vala"
						_tmp52_ = _tmp51_;
#line 174 "../src/Widgets/Device.vala"
						_tmp53_ = g_strdup_printf (_ ("Sending… %s of %s"), _tmp47_, _tmp52_);
#line 174 "../src/Widgets/Device.vala"
						_tmp54_ = _tmp53_;
#line 174 "../src/Widgets/Device.vala"
						gtk_label_set_label (_tmp42_, _tmp54_);
#line 174 "../src/Widgets/Device.vala"
						_g_free0 (_tmp54_);
#line 174 "../src/Widgets/Device.vala"
						_g_free0 (_tmp52_);
#line 174 "../src/Widgets/Device.vala"
						_g_free0 (_tmp47_);
#line 550 "Device.c"
					}
				}
#line 179 "../src/Widgets/Device.vala"
				_g_free0 (filename);
#line 179 "../src/Widgets/Device.vala"
				_g_free0 (name);
#line 179 "../src/Widgets/Device.vala"
				break;
#line 559 "Device.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("complete")))) {
#line 153 "../src/Widgets/Device.vala"
		switch (0) {
#line 565 "Device.c"
			default:
			{
#line 181 "../src/Widgets/Device.vala"
				bluetooth_indicator_widgets_device_hide_action (self);
#line 182 "../src/Widgets/Device.vala"
				break;
#line 572 "Device.c"
			}
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 594 "Device.c"
}

static gboolean
bluetooth_indicator_widgets_device_bt_status (BluetoothIndicatorWidgetsDevice* self,
                                              const gchar* filename)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 185 "../src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 185 "../src/Widgets/Device.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 186 "../src/Widgets/Device.vala"
	if (string_contains (filename, "/.cache/obexd")) {
#line 186 "../src/Widgets/Device.vala"
		_tmp0_ = TRUE;
#line 611 "Device.c"
	} else {
#line 186 "../src/Widgets/Device.vala"
		_tmp0_ = FALSE;
#line 615 "Device.c"
	}
#line 186 "../src/Widgets/Device.vala"
	result = _tmp0_;
#line 186 "../src/Widgets/Device.vala"
	return result;
#line 621 "Device.c"
}

void
bluetooth_indicator_widgets_device_hide_action (BluetoothIndicatorWidgetsDevice* self)
{
	GtkLabel* _tmp0_;
	GtkRevealer* _tmp1_;
#line 188 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->progress_label;
#line 189 "../src/Widgets/Device.vala"
	gtk_label_set_label (_tmp0_, "");
#line 190 "../src/Widgets/Device.vala"
	_tmp1_ = self->priv->progress_revealer;
#line 190 "../src/Widgets/Device.vala"
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
#line 639 "Device.c"
}

static void
bluetooth_indicator_widgets_device_toggle_device_data_free (gpointer _data)
{
	BluetoothIndicatorWidgetsDeviceToggleDeviceData* _data_;
	_data_ = _data;
#line 18 "../src/Widgets/Device.vala"
	_g_object_unref0 (_data_->self);
#line 18 "../src/Widgets/Device.vala"
	g_slice_free (BluetoothIndicatorWidgetsDeviceToggleDeviceData, _data_);
#line 651 "Device.c"
}

void
bluetooth_indicator_widgets_device_toggle_device (BluetoothIndicatorWidgetsDevice* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	BluetoothIndicatorWidgetsDeviceToggleDeviceData* _data_;
	BluetoothIndicatorWidgetsDevice* _tmp0_;
#line 18 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/Widgets/Device.vala"
	_data_ = g_slice_new0 (BluetoothIndicatorWidgetsDeviceToggleDeviceData);
#line 18 "../src/Widgets/Device.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 18 "../src/Widgets/Device.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_indicator_widgets_device_toggle_device_data_free);
#line 18 "../src/Widgets/Device.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 18 "../src/Widgets/Device.vala"
	_data_->self = _tmp0_;
#line 18 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_toggle_device_co (_data_);
#line 675 "Device.c"
}

void
bluetooth_indicator_widgets_device_toggle_device_finish (BluetoothIndicatorWidgetsDevice* self,
                                                         GAsyncResult* _res_)
{
	BluetoothIndicatorWidgetsDeviceToggleDeviceData* _data_;
#line 18 "../src/Widgets/Device.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 685 "Device.c"
}

static void
bluetooth_indicator_widgets_device_toggle_device_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	BluetoothIndicatorWidgetsDeviceToggleDeviceData* _data_;
#line 196 "../src/Widgets/Device.vala"
	_data_ = _user_data_;
#line 196 "../src/Widgets/Device.vala"
	_data_->_source_object_ = source_object;
#line 196 "../src/Widgets/Device.vala"
	_data_->_res_ = _res_;
#line 196 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_toggle_device_co (_data_);
#line 702 "Device.c"
}

static gboolean
bluetooth_indicator_widgets_device_toggle_device_co (BluetoothIndicatorWidgetsDeviceToggleDeviceData* _data_)
{
#line 193 "../src/Widgets/Device.vala"
	switch (_data_->_state_) {
#line 193 "../src/Widgets/Device.vala"
		case 0:
#line 712 "Device.c"
		goto _state_0;
#line 193 "../src/Widgets/Device.vala"
		case 1:
#line 716 "Device.c"
		goto _state_1;
#line 193 "../src/Widgets/Device.vala"
		case 2:
#line 720 "Device.c"
		goto _state_2;
#line 193 "../src/Widgets/Device.vala"
		case 3:
#line 724 "Device.c"
		goto _state_3;
#line 193 "../src/Widgets/Device.vala"
		case 4:
#line 728 "Device.c"
		goto _state_4;
		default:
#line 193 "../src/Widgets/Device.vala"
		g_assert_not_reached ();
#line 733 "Device.c"
	}
	_state_0:
#line 194 "../src/Widgets/Device.vala"
	_data_->_tmp0_ = _data_->self->priv->progress_revealer;
#line 194 "../src/Widgets/Device.vala"
	_data_->_tmp1_ = gtk_revealer_get_child_revealed (_data_->_tmp0_);
#line 194 "../src/Widgets/Device.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 194 "../src/Widgets/Device.vala"
	if (_data_->_tmp2_) {
#line 744 "Device.c"
		{
#line 196 "../src/Widgets/Device.vala"
			_data_->_state_ = 1;
#line 196 "../src/Widgets/Device.vala"
			g_bus_get (G_BUS_TYPE_SESSION, NULL, bluetooth_indicator_widgets_device_toggle_device_ready, _data_);
#line 196 "../src/Widgets/Device.vala"
			return FALSE;
#line 752 "Device.c"
			_state_1:
#line 196 "../src/Widgets/Device.vala"
			_data_->_tmp3_ = g_bus_get_finish (_data_->_res_, &_data_->_inner_error0_);
#line 196 "../src/Widgets/Device.vala"
			_data_->connection = _data_->_tmp3_;
#line 196 "../src/Widgets/Device.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 760 "Device.c"
				goto __catch0_g_error;
			}
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp4_ = _data_->connection;
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp5_ = _data_->self->transfer;
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp6_ = bluetooth_indicator_services_obex_transfer_get_session (_data_->_tmp5_);
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp9_ = g_variant_new ("(s)", _data_->_tmp8_, NULL);
#line 197 "../src/Widgets/Device.vala"
			g_variant_ref_sink (_data_->_tmp9_);
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 197 "../src/Widgets/Device.vala"
			_data_->_state_ = 2;
#line 197 "../src/Widgets/Device.vala"
			g_dbus_connection_call (_data_->_tmp4_, BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_AGENT, BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_PATH, BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_AGENT, "TransferActive", _data_->_tmp10_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, bluetooth_indicator_widgets_device_toggle_device_ready, _data_);
#line 197 "../src/Widgets/Device.vala"
			return FALSE;
#line 785 "Device.c"
			_state_2:
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp11_ = g_dbus_connection_call_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 197 "../src/Widgets/Device.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 197 "../src/Widgets/Device.vala"
			_g_variant_unref0 (_data_->_tmp12_);
#line 197 "../src/Widgets/Device.vala"
			_g_variant_unref0 (_data_->_tmp10_);
#line 197 "../src/Widgets/Device.vala"
			_g_free0 (_data_->_tmp8_);
#line 197 "../src/Widgets/Device.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 197 "../src/Widgets/Device.vala"
				_g_object_unref0 (_data_->connection);
#line 801 "Device.c"
				goto __catch0_g_error;
			}
#line 195 "../src/Widgets/Device.vala"
			_g_object_unref0 (_data_->connection);
#line 806 "Device.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 195 "../src/Widgets/Device.vala"
			_data_->e = _data_->_inner_error0_;
#line 195 "../src/Widgets/Device.vala"
			_data_->_inner_error0_ = NULL;
#line 209 "../src/Widgets/Device.vala"
			_data_->_tmp13_ = _data_->e;
#line 209 "../src/Widgets/Device.vala"
			_data_->_tmp14_ = _data_->_tmp13_->message;
#line 209 "../src/Widgets/Device.vala"
			g_critical ("Device.vala:209: %s", _data_->_tmp14_);
#line 195 "../src/Widgets/Device.vala"
			_g_error_free0 (_data_->e);
#line 823 "Device.c"
		}
		__finally0:
#line 195 "../src/Widgets/Device.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 195 "../src/Widgets/Device.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 195 "../src/Widgets/Device.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 195 "../src/Widgets/Device.vala"
			g_object_unref (_data_->_async_result);
#line 195 "../src/Widgets/Device.vala"
			return FALSE;
#line 836 "Device.c"
		}
#line 211 "../src/Widgets/Device.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 211 "../src/Widgets/Device.vala"
		if (_data_->_state_ != 0) {
#line 211 "../src/Widgets/Device.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 211 "../src/Widgets/Device.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 846 "Device.c"
			}
		}
#line 211 "../src/Widgets/Device.vala"
		g_object_unref (_data_->_async_result);
#line 211 "../src/Widgets/Device.vala"
		return FALSE;
#line 853 "Device.c"
	}
#line 213 "../src/Widgets/Device.vala"
	_data_->_tmp15_ = _data_->self->priv->spinner;
#line 213 "../src/Widgets/Device.vala"
	g_object_get (_data_->_tmp15_, "active", &_data_->_tmp16_, NULL);
#line 213 "../src/Widgets/Device.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 213 "../src/Widgets/Device.vala"
	if (_data_->_tmp17_) {
#line 214 "../src/Widgets/Device.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 214 "../src/Widgets/Device.vala"
		if (_data_->_state_ != 0) {
#line 214 "../src/Widgets/Device.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 214 "../src/Widgets/Device.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 871 "Device.c"
			}
		}
#line 214 "../src/Widgets/Device.vala"
		g_object_unref (_data_->_async_result);
#line 214 "../src/Widgets/Device.vala"
		return FALSE;
#line 878 "Device.c"
	}
#line 217 "../src/Widgets/Device.vala"
	_data_->_tmp18_ = _data_->self->priv->spinner;
#line 217 "../src/Widgets/Device.vala"
	g_object_set (_data_->_tmp18_, "active", TRUE, NULL);
#line 218 "../src/Widgets/Device.vala"
	_data_->_tmp19_ = _data_->self->priv->status_image;
#line 218 "../src/Widgets/Device.vala"
	g_object_set (_data_->_tmp19_, "icon-name", "user-away", NULL);
#line 888 "Device.c"
	{
#line 220 "../src/Widgets/Device.vala"
		_data_->_tmp20_ = _data_->self->priv->_device;
#line 220 "../src/Widgets/Device.vala"
		_data_->_tmp21_ = bluetooth_indicator_services_device_get_connected (_data_->_tmp20_);
#line 220 "../src/Widgets/Device.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 220 "../src/Widgets/Device.vala"
		if (!_data_->_tmp22_) {
#line 221 "../src/Widgets/Device.vala"
			_data_->_tmp23_ = _data_->self->priv->status_label;
#line 221 "../src/Widgets/Device.vala"
			gtk_label_set_label (_data_->_tmp23_, _ ("Connecting…"));
#line 222 "../src/Widgets/Device.vala"
			_data_->_tmp24_ = _data_->self->priv->_device;
#line 222 "../src/Widgets/Device.vala"
			_data_->_state_ = 3;
#line 222 "../src/Widgets/Device.vala"
			bluetooth_indicator_services_device_connect (_data_->_tmp24_, bluetooth_indicator_widgets_device_toggle_device_ready, _data_);
#line 222 "../src/Widgets/Device.vala"
			return FALSE;
#line 910 "Device.c"
			_state_3:
#line 222 "../src/Widgets/Device.vala"
			bluetooth_indicator_services_device_connect_finish (_data_->_tmp24_, _data_->_res_, &_data_->_inner_error0_);
#line 222 "../src/Widgets/Device.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 916 "Device.c"
				goto __catch1_g_error;
			}
		} else {
#line 224 "../src/Widgets/Device.vala"
			_data_->_tmp25_ = _data_->self->priv->status_label;
#line 224 "../src/Widgets/Device.vala"
			gtk_label_set_label (_data_->_tmp25_, _ ("Disconnecting…"));
#line 225 "../src/Widgets/Device.vala"
			_data_->_tmp26_ = _data_->self->priv->_device;
#line 225 "../src/Widgets/Device.vala"
			_data_->_state_ = 4;
#line 225 "../src/Widgets/Device.vala"
			bluetooth_indicator_services_device_disconnect (_data_->_tmp26_, bluetooth_indicator_widgets_device_toggle_device_ready, _data_);
#line 225 "../src/Widgets/Device.vala"
			return FALSE;
#line 932 "Device.c"
			_state_4:
#line 225 "../src/Widgets/Device.vala"
			bluetooth_indicator_services_device_disconnect_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
#line 225 "../src/Widgets/Device.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 938 "Device.c"
				goto __catch1_g_error;
			}
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 219 "../src/Widgets/Device.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 219 "../src/Widgets/Device.vala"
		_data_->_inner_error0_ = NULL;
#line 228 "../src/Widgets/Device.vala"
		_data_->_tmp27_ = _data_->_vala1_e;
#line 228 "../src/Widgets/Device.vala"
		_data_->_tmp28_ = _data_->_tmp27_->message;
#line 228 "../src/Widgets/Device.vala"
		g_critical ("Device.vala:228: %s", _data_->_tmp28_);
#line 229 "../src/Widgets/Device.vala"
		_data_->_tmp29_ = _data_->self->priv->status_label;
#line 229 "../src/Widgets/Device.vala"
		gtk_label_set_label (_data_->_tmp29_, _ ("Unable to Connect"));
#line 230 "../src/Widgets/Device.vala"
		_data_->_tmp30_ = _data_->self->priv->status_image;
#line 230 "../src/Widgets/Device.vala"
		g_object_set (_data_->_tmp30_, "icon-name", "user-busy", NULL);
#line 219 "../src/Widgets/Device.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 966 "Device.c"
	}
	__finally1:
#line 219 "../src/Widgets/Device.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 219 "../src/Widgets/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 219 "../src/Widgets/Device.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 219 "../src/Widgets/Device.vala"
		g_object_unref (_data_->_async_result);
#line 219 "../src/Widgets/Device.vala"
		return FALSE;
#line 979 "Device.c"
	}
#line 233 "../src/Widgets/Device.vala"
	_data_->_tmp31_ = _data_->self->priv->spinner;
#line 233 "../src/Widgets/Device.vala"
	g_object_set (_data_->_tmp31_, "active", FALSE, NULL);
#line 193 "../src/Widgets/Device.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 193 "../src/Widgets/Device.vala"
	if (_data_->_state_ != 0) {
#line 193 "../src/Widgets/Device.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 193 "../src/Widgets/Device.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 993 "Device.c"
		}
	}
#line 193 "../src/Widgets/Device.vala"
	g_object_unref (_data_->_async_result);
#line 193 "../src/Widgets/Device.vala"
	return FALSE;
#line 1000 "Device.c"
}

static void
bluetooth_indicator_widgets_device_update_status (BluetoothIndicatorWidgetsDevice* self)
{
	gchar* device_name = NULL;
	BluetoothIndicatorServicesDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkLabel* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	BluetoothIndicatorServicesDevice* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	gchar* _tmp42_ = NULL;
	BluetoothIndicatorServicesDevice* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gboolean _tmp47_;
	GtkImage* _tmp52_;
#line 236 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->_device;
#line 237 "../src/Widgets/Device.vala"
	_tmp1_ = bluetooth_indicator_services_device_get_alias (_tmp0_);
#line 237 "../src/Widgets/Device.vala"
	_tmp2_ = _tmp1_;
#line 237 "../src/Widgets/Device.vala"
	device_name = _tmp2_;
#line 238 "../src/Widgets/Device.vala"
	_tmp3_ = device_name;
#line 238 "../src/Widgets/Device.vala"
	if (_tmp3_ == NULL) {
#line 1041 "Device.c"
		BluetoothIndicatorServicesDevice* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
#line 239 "../src/Widgets/Device.vala"
		_tmp4_ = self->priv->_device;
#line 239 "../src/Widgets/Device.vala"
		_tmp5_ = bluetooth_indicator_services_device_get_icon (_tmp4_);
#line 239 "../src/Widgets/Device.vala"
		_tmp6_ = _tmp5_;
#line 239 "../src/Widgets/Device.vala"
		_tmp7_ = _tmp6_;
#line 239 "../src/Widgets/Device.vala"
		_tmp8_ = _tmp7_ != NULL;
#line 239 "../src/Widgets/Device.vala"
		_g_free0 (_tmp7_);
#line 239 "../src/Widgets/Device.vala"
		if (_tmp8_) {
#line 1061 "Device.c"
			BluetoothIndicatorServicesDevice* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GQuark _tmp14_ = 0U;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label0 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label1 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label2 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label3 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label4 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label5 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label6 = 0;
#line 240 "../src/Widgets/Device.vala"
			static GQuark _tmp13_label7 = 0;
#line 240 "../src/Widgets/Device.vala"
			_tmp9_ = self->priv->_device;
#line 240 "../src/Widgets/Device.vala"
			_tmp10_ = bluetooth_indicator_services_device_get_icon (_tmp9_);
#line 240 "../src/Widgets/Device.vala"
			_tmp11_ = _tmp10_;
#line 240 "../src/Widgets/Device.vala"
			_tmp12_ = _tmp11_;
#line 240 "../src/Widgets/Device.vala"
			_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
#line 240 "../src/Widgets/Device.vala"
			g_free (_tmp12_);
#line 240 "../src/Widgets/Device.vala"
			if (_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("audio-card")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1099 "Device.c"
					default:
					{
						gchar* _tmp15_;
#line 242 "../src/Widgets/Device.vala"
						_tmp15_ = g_strdup (_ ("Speaker"));
#line 242 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 242 "../src/Widgets/Device.vala"
						device_name = _tmp15_;
#line 243 "../src/Widgets/Device.vala"
						break;
#line 1111 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("audio-headphones")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1117 "Device.c"
					default:
					{
						gchar* _tmp16_;
#line 245 "../src/Widgets/Device.vala"
						_tmp16_ = g_strdup (_ ("Headphones"));
#line 245 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 245 "../src/Widgets/Device.vala"
						device_name = _tmp16_;
#line 246 "../src/Widgets/Device.vala"
						break;
#line 1129 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label2) ? _tmp13_label2 : (_tmp13_label2 = g_quark_from_static_string ("input-gaming")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1135 "Device.c"
					default:
					{
						gchar* _tmp17_;
#line 248 "../src/Widgets/Device.vala"
						_tmp17_ = g_strdup (_ ("Controller"));
#line 248 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 248 "../src/Widgets/Device.vala"
						device_name = _tmp17_;
#line 249 "../src/Widgets/Device.vala"
						break;
#line 1147 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label3) ? _tmp13_label3 : (_tmp13_label3 = g_quark_from_static_string ("input-keyboard")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1153 "Device.c"
					default:
					{
						gchar* _tmp18_;
#line 251 "../src/Widgets/Device.vala"
						_tmp18_ = g_strdup (_ ("Keyboard"));
#line 251 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 251 "../src/Widgets/Device.vala"
						device_name = _tmp18_;
#line 252 "../src/Widgets/Device.vala"
						break;
#line 1165 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label4) ? _tmp13_label4 : (_tmp13_label4 = g_quark_from_static_string ("input-mouse")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1171 "Device.c"
					default:
					{
						gchar* _tmp19_;
#line 254 "../src/Widgets/Device.vala"
						_tmp19_ = g_strdup (_ ("Mouse"));
#line 254 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 254 "../src/Widgets/Device.vala"
						device_name = _tmp19_;
#line 255 "../src/Widgets/Device.vala"
						break;
#line 1183 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label5) ? _tmp13_label5 : (_tmp13_label5 = g_quark_from_static_string ("input-tablet")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1189 "Device.c"
					default:
					{
						gchar* _tmp20_;
#line 257 "../src/Widgets/Device.vala"
						_tmp20_ = g_strdup (_ ("Tablet"));
#line 257 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 257 "../src/Widgets/Device.vala"
						device_name = _tmp20_;
#line 258 "../src/Widgets/Device.vala"
						break;
#line 1201 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label6) ? _tmp13_label6 : (_tmp13_label6 = g_quark_from_static_string ("input-touchpad")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1207 "Device.c"
					default:
					{
						gchar* _tmp21_;
#line 260 "../src/Widgets/Device.vala"
						_tmp21_ = g_strdup (_ ("Touchpad"));
#line 260 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 260 "../src/Widgets/Device.vala"
						device_name = _tmp21_;
#line 261 "../src/Widgets/Device.vala"
						break;
#line 1219 "Device.c"
					}
				}
			} else if (_tmp14_ == ((0 != _tmp13_label7) ? _tmp13_label7 : (_tmp13_label7 = g_quark_from_static_string ("phone")))) {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1225 "Device.c"
					default:
					{
						gchar* _tmp22_;
#line 263 "../src/Widgets/Device.vala"
						_tmp22_ = g_strdup (_ ("Phone"));
#line 263 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 263 "../src/Widgets/Device.vala"
						device_name = _tmp22_;
#line 264 "../src/Widgets/Device.vala"
						break;
#line 1237 "Device.c"
					}
				}
			} else {
#line 240 "../src/Widgets/Device.vala"
				switch (0) {
#line 1243 "Device.c"
					default:
					{
						BluetoothIndicatorServicesDevice* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
#line 266 "../src/Widgets/Device.vala"
						_tmp23_ = self->priv->_device;
#line 266 "../src/Widgets/Device.vala"
						_tmp24_ = bluetooth_indicator_services_device_get_address (_tmp23_);
#line 266 "../src/Widgets/Device.vala"
						_tmp25_ = _tmp24_;
#line 266 "../src/Widgets/Device.vala"
						_g_free0 (device_name);
#line 266 "../src/Widgets/Device.vala"
						device_name = _tmp25_;
#line 267 "../src/Widgets/Device.vala"
						break;
#line 1261 "Device.c"
					}
				}
			}
		} else {
			BluetoothIndicatorServicesDevice* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 270 "../src/Widgets/Device.vala"
			_tmp26_ = self->priv->_device;
#line 270 "../src/Widgets/Device.vala"
			_tmp27_ = bluetooth_indicator_services_device_get_address (_tmp26_);
#line 270 "../src/Widgets/Device.vala"
			_tmp28_ = _tmp27_;
#line 270 "../src/Widgets/Device.vala"
			_g_free0 (device_name);
#line 270 "../src/Widgets/Device.vala"
			device_name = _tmp28_;
#line 1279 "Device.c"
		}
	}
#line 274 "../src/Widgets/Device.vala"
	_tmp29_ = self->priv->name_label;
#line 274 "../src/Widgets/Device.vala"
	_tmp30_ = device_name;
#line 274 "../src/Widgets/Device.vala"
	_tmp31_ = g_markup_escape_text (_tmp30_, (gssize) -1);
#line 274 "../src/Widgets/Device.vala"
	_tmp32_ = _tmp31_;
#line 274 "../src/Widgets/Device.vala"
	_tmp33_ = g_strdup_printf ("<b>%s</b>", _tmp32_);
#line 274 "../src/Widgets/Device.vala"
	_tmp34_ = _tmp33_;
#line 274 "../src/Widgets/Device.vala"
	gtk_label_set_label (_tmp29_, _tmp34_);
#line 274 "../src/Widgets/Device.vala"
	_g_free0 (_tmp34_);
#line 274 "../src/Widgets/Device.vala"
	_g_free0 (_tmp32_);
#line 276 "../src/Widgets/Device.vala"
	_tmp35_ = self->priv->_device;
#line 276 "../src/Widgets/Device.vala"
	_tmp36_ = bluetooth_indicator_services_device_get_connected (_tmp35_);
#line 276 "../src/Widgets/Device.vala"
	_tmp37_ = _tmp36_;
#line 276 "../src/Widgets/Device.vala"
	if (_tmp37_) {
#line 1308 "Device.c"
		GtkLabel* _tmp38_;
		GtkImage* _tmp39_;
#line 277 "../src/Widgets/Device.vala"
		_tmp38_ = self->priv->status_label;
#line 277 "../src/Widgets/Device.vala"
		gtk_label_set_label (_tmp38_, _ ("Connected"));
#line 278 "../src/Widgets/Device.vala"
		_tmp39_ = self->priv->status_image;
#line 278 "../src/Widgets/Device.vala"
		g_object_set (_tmp39_, "icon-name", "user-available", NULL);
#line 1319 "Device.c"
	} else {
		GtkLabel* _tmp40_;
		GtkImage* _tmp41_;
#line 280 "../src/Widgets/Device.vala"
		_tmp40_ = self->priv->status_label;
#line 280 "../src/Widgets/Device.vala"
		gtk_label_set_label (_tmp40_, _ ("Not Connected"));
#line 281 "../src/Widgets/Device.vala"
		_tmp41_ = self->priv->status_image;
#line 281 "../src/Widgets/Device.vala"
		g_object_set (_tmp41_, "icon-name", "user-offline", NULL);
#line 1331 "Device.c"
	}
#line 284 "../src/Widgets/Device.vala"
	_tmp43_ = self->priv->_device;
#line 284 "../src/Widgets/Device.vala"
	_tmp44_ = bluetooth_indicator_services_device_get_icon (_tmp43_);
#line 284 "../src/Widgets/Device.vala"
	_tmp45_ = _tmp44_;
#line 284 "../src/Widgets/Device.vala"
	_tmp46_ = _tmp45_;
#line 284 "../src/Widgets/Device.vala"
	_tmp47_ = _tmp46_ == NULL;
#line 284 "../src/Widgets/Device.vala"
	_g_free0 (_tmp46_);
#line 284 "../src/Widgets/Device.vala"
	if (_tmp47_) {
#line 1347 "Device.c"
		gchar* _tmp48_;
#line 284 "../src/Widgets/Device.vala"
		_tmp48_ = g_strdup (BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEFAULT_ICON);
#line 284 "../src/Widgets/Device.vala"
		_g_free0 (_tmp42_);
#line 284 "../src/Widgets/Device.vala"
		_tmp42_ = _tmp48_;
#line 1355 "Device.c"
	} else {
		BluetoothIndicatorServicesDevice* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 284 "../src/Widgets/Device.vala"
		_tmp49_ = self->priv->_device;
#line 284 "../src/Widgets/Device.vala"
		_tmp50_ = bluetooth_indicator_services_device_get_icon (_tmp49_);
#line 284 "../src/Widgets/Device.vala"
		_tmp51_ = _tmp50_;
#line 284 "../src/Widgets/Device.vala"
		_g_free0 (_tmp42_);
#line 284 "../src/Widgets/Device.vala"
		_tmp42_ = _tmp51_;
#line 1370 "Device.c"
	}
#line 284 "../src/Widgets/Device.vala"
	_tmp52_ = self->priv->icon_image;
#line 284 "../src/Widgets/Device.vala"
	g_object_set (_tmp52_, "icon-name", _tmp42_, NULL);
#line 236 "../src/Widgets/Device.vala"
	_g_free0 (_tmp42_);
#line 236 "../src/Widgets/Device.vala"
	_g_free0 (device_name);
#line 1380 "Device.c"
}

BluetoothIndicatorServicesDevice*
bluetooth_indicator_widgets_device_get_device (BluetoothIndicatorWidgetsDevice* self)
{
	BluetoothIndicatorServicesDevice* result;
	BluetoothIndicatorServicesDevice* _tmp0_;
#line 23 "../src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->_device;
#line 23 "../src/Widgets/Device.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/Device.vala"
	return result;
#line 1396 "Device.c"
}

static void
bluetooth_indicator_widgets_device_set_device (BluetoothIndicatorWidgetsDevice* self,
                                               BluetoothIndicatorServicesDevice* value)
{
	BluetoothIndicatorServicesDevice* old_value;
#line 23 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/Device.vala"
	old_value = bluetooth_indicator_widgets_device_get_device (self);
#line 23 "../src/Widgets/Device.vala"
	if (old_value != value) {
#line 1410 "Device.c"
		BluetoothIndicatorServicesDevice* _tmp0_;
#line 23 "../src/Widgets/Device.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/Device.vala"
		_g_object_unref0 (self->priv->_device);
#line 23 "../src/Widgets/Device.vala"
		self->priv->_device = _tmp0_;
#line 23 "../src/Widgets/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_indicator_widgets_device_properties[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEVICE_PROPERTY]);
#line 1420 "Device.c"
	}
}

BluetoothIndicatorServicesObexManager*
bluetooth_indicator_widgets_device_get_obex_manager (BluetoothIndicatorWidgetsDevice* self)
{
	BluetoothIndicatorServicesObexManager* result;
	BluetoothIndicatorServicesObexManager* _tmp0_;
#line 24 "../src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->_obex_manager;
#line 24 "../src/Widgets/Device.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/Device.vala"
	return result;
#line 1437 "Device.c"
}

static void
bluetooth_indicator_widgets_device_set_obex_manager (BluetoothIndicatorWidgetsDevice* self,
                                                     BluetoothIndicatorServicesObexManager* value)
{
	BluetoothIndicatorServicesObexManager* old_value;
#line 24 "../src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/Device.vala"
	old_value = bluetooth_indicator_widgets_device_get_obex_manager (self);
#line 24 "../src/Widgets/Device.vala"
	if (old_value != value) {
#line 1451 "Device.c"
		BluetoothIndicatorServicesObexManager* _tmp0_;
#line 24 "../src/Widgets/Device.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/Device.vala"
		_g_object_unref0 (self->priv->_obex_manager);
#line 24 "../src/Widgets/Device.vala"
		self->priv->_obex_manager = _tmp0_;
#line 24 "../src/Widgets/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_indicator_widgets_device_properties[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_MANAGER_PROPERTY]);
#line 1461 "Device.c"
	}
}

static void
_bluetooth_indicator_widgets_device_on_obex_transfer_added_bluetooth_indicator_services_obex_manager_transfer_added (BluetoothIndicatorServicesObexManager* _sender,
                                                                                                                     const gchar* address,
                                                                                                                     BluetoothIndicatorServicesObexTransfer* transfer,
                                                                                                                     gpointer self)
{
#line 43 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_on_obex_transfer_added ((BluetoothIndicatorWidgetsDevice*) self, address, transfer);
#line 1473 "Device.c"
}

static void
_bluetooth_indicator_widgets_device_on_obex_transfer_removed_bluetooth_indicator_services_obex_manager_transfer_removed (BluetoothIndicatorServicesObexManager* _sender,
                                                                                                                         BluetoothIndicatorServicesObexTransfer* transfer,
                                                                                                                         gpointer self)
{
#line 44 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_on_obex_transfer_removed ((BluetoothIndicatorWidgetsDevice*) self, transfer);
#line 1483 "Device.c"
}

static void
_bluetooth_indicator_widgets_device_on_obex_transfer_active_bluetooth_indicator_services_obex_manager_transfer_active (BluetoothIndicatorServicesObexManager* _sender,
                                                                                                                       const gchar* address,
                                                                                                                       gpointer self)
{
#line 45 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_on_obex_transfer_active ((BluetoothIndicatorWidgetsDevice*) self, address);
#line 1493 "Device.c"
}

static void
_bluetooth_indicator_widgets_device_update_status_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                                     GVariant* changed_properties,
                                                                                     gchar** invalidated_properties,
                                                                                     gpointer self)
{
#line 126 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_update_status ((BluetoothIndicatorWidgetsDevice*) self);
#line 1504 "Device.c"
}

static void
_bluetooth_indicator_widgets_device___lambda22_ (BluetoothIndicatorWidgetsDevice* self,
                                                 BluetoothIndicatorServicesObexTransfer* transfer,
                                                 const gchar* address)
{
#line 131 "../src/Widgets/Device.vala"
	g_return_if_fail (transfer != NULL);
#line 131 "../src/Widgets/Device.vala"
	g_return_if_fail (address != NULL);
#line 132 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_on_obex_transfer_added (self, address, transfer);
#line 1518 "Device.c"
}

static void
__bluetooth_indicator_widgets_device___lambda22__gh_func (gconstpointer key,
                                                          gconstpointer value,
                                                          gpointer self)
{
#line 131 "../src/Widgets/Device.vala"
	_bluetooth_indicator_widgets_device___lambda22_ ((BluetoothIndicatorWidgetsDevice*) self, (BluetoothIndicatorServicesObexTransfer*) key, (const gchar*) value);
#line 1528 "Device.c"
}

static GObject *
bluetooth_indicator_widgets_device_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothIndicatorWidgetsDevice * self;
	BluetoothIndicatorServicesObexManager* _tmp0_;
	BluetoothIndicatorServicesObexManager* _tmp1_;
	BluetoothIndicatorServicesObexManager* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_ = NULL;
	GtkSpinner* _tmp5_ = NULL;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp6_;
	GtkSizeGroup* _tmp7_;
	GtkLabel* _tmp8_;
	GtkSizeGroup* _tmp9_;
	GtkSpinner* _tmp10_;
	gchar* _tmp11_ = NULL;
	BluetoothIndicatorServicesDevice* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gboolean _tmp16_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_ = NULL;
	GtkLabel* _tmp23_ = NULL;
	GtkProgressBar* _tmp24_ = NULL;
	GtkLabel* _tmp25_ = NULL;
	GtkGrid* content_grid = NULL;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkLabel* _tmp28_;
	GtkGrid* _tmp29_;
	GtkProgressBar* _tmp30_;
	GtkGrid* _tmp31_;
	GtkLabel* _tmp32_;
	GtkRevealer* _tmp33_ = NULL;
	GtkRevealer* _tmp34_;
	GtkGrid* _tmp35_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp36_;
	GtkOverlay* _tmp37_;
	GtkImage* _tmp38_;
	GtkOverlay* _tmp39_;
	GtkImage* _tmp40_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp41_ = NULL;
	GtkGrid* _tmp42_;
	GtkOverlay* _tmp43_;
	GtkGrid* _tmp44_;
	GtkLabel* _tmp45_;
	GtkGrid* _tmp46_;
	GtkLabel* _tmp47_;
	GtkGrid* _tmp48_;
	GtkSpinner* _tmp49_;
	GtkGrid* box_grid = NULL;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkGrid* _tmp53_;
	GtkRevealer* _tmp54_;
	GtkGrid* _tmp55_;
	BluetoothIndicatorServicesDevice* _tmp56_;
	GtkStyleContext* _tmp57_;
	BluetoothIndicatorServicesObexManager* _tmp58_;
	GHashTable* _tmp59_;
#line 42 "../src/Widgets/Device.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_indicator_widgets_device_parent_class);
#line 42 "../src/Widgets/Device.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 42 "../src/Widgets/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_INDICATOR_WIDGETS_TYPE_DEVICE, BluetoothIndicatorWidgetsDevice);
#line 43 "../src/Widgets/Device.vala"
	_tmp0_ = self->priv->_obex_manager;
#line 43 "../src/Widgets/Device.vala"
	g_signal_connect_object (_tmp0_, "transfer-added", (GCallback) _bluetooth_indicator_widgets_device_on_obex_transfer_added_bluetooth_indicator_services_obex_manager_transfer_added, self, 0);
#line 44 "../src/Widgets/Device.vala"
	_tmp1_ = self->priv->_obex_manager;
#line 44 "../src/Widgets/Device.vala"
	g_signal_connect_object (_tmp1_, "transfer-removed", (GCallback) _bluetooth_indicator_widgets_device_on_obex_transfer_removed_bluetooth_indicator_services_obex_manager_transfer_removed, self, 0);
#line 45 "../src/Widgets/Device.vala"
	_tmp2_ = self->priv->_obex_manager;
#line 45 "../src/Widgets/Device.vala"
	g_signal_connect_object (_tmp2_, "transfer-active", (GCallback) _bluetooth_indicator_widgets_device_on_obex_transfer_active_bluetooth_indicator_services_obex_manager_transfer_active, self, 0);
#line 47 "../src/Widgets/Device.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (NULL);
#line 47 "../src/Widgets/Device.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 47 "../src/Widgets/Device.vala"
	gtk_label_set_use_markup (_tmp3_, TRUE);
#line 47 "../src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
#line 47 "../src/Widgets/Device.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 47 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp3_);
#line 47 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->name_label);
#line 47 "../src/Widgets/Device.vala"
	self->priv->name_label = _tmp3_;
#line 54 "../src/Widgets/Device.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Not Connected"));
#line 54 "../src/Widgets/Device.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_START);
#line 54 "../src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_START);
#line 54 "../src/Widgets/Device.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp4_, TRUE);
#line 54 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp4_);
#line 54 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->status_label);
#line 54 "../src/Widgets/Device.vala"
	self->priv->status_label = _tmp4_;
#line 60 "../src/Widgets/Device.vala"
	_tmp5_ = (GtkSpinner*) gtk_spinner_new ();
#line 60 "../src/Widgets/Device.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_START);
#line 60 "../src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_START);
#line 60 "../src/Widgets/Device.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp5_, TRUE);
#line 60 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp5_);
#line 60 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->spinner);
#line 60 "../src/Widgets/Device.vala"
	self->priv->spinner = _tmp5_;
#line 66 "../src/Widgets/Device.vala"
	_tmp6_ = gtk_size_group_new (GTK_SIZE_GROUP_VERTICAL);
#line 66 "../src/Widgets/Device.vala"
	size_group = _tmp6_;
#line 67 "../src/Widgets/Device.vala"
	_tmp7_ = size_group;
#line 67 "../src/Widgets/Device.vala"
	_tmp8_ = self->priv->status_label;
#line 67 "../src/Widgets/Device.vala"
	gtk_size_group_add_widget (_tmp7_, (GtkWidget*) _tmp8_);
#line 68 "../src/Widgets/Device.vala"
	_tmp9_ = size_group;
#line 68 "../src/Widgets/Device.vala"
	_tmp10_ = self->priv->spinner;
#line 68 "../src/Widgets/Device.vala"
	gtk_size_group_add_widget (_tmp9_, (GtkWidget*) _tmp10_);
#line 70 "../src/Widgets/Device.vala"
	_tmp12_ = self->priv->_device;
#line 70 "../src/Widgets/Device.vala"
	_tmp13_ = bluetooth_indicator_services_device_get_icon (_tmp12_);
#line 70 "../src/Widgets/Device.vala"
	_tmp14_ = _tmp13_;
#line 70 "../src/Widgets/Device.vala"
	_tmp15_ = _tmp14_;
#line 70 "../src/Widgets/Device.vala"
	_tmp16_ = _tmp15_ == NULL;
#line 70 "../src/Widgets/Device.vala"
	_g_free0 (_tmp15_);
#line 70 "../src/Widgets/Device.vala"
	if (_tmp16_) {
#line 1692 "Device.c"
		gchar* _tmp17_;
#line 70 "../src/Widgets/Device.vala"
		_tmp17_ = g_strdup (BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEFAULT_ICON);
#line 70 "../src/Widgets/Device.vala"
		_g_free0 (_tmp11_);
#line 70 "../src/Widgets/Device.vala"
		_tmp11_ = _tmp17_;
#line 1700 "Device.c"
	} else {
		BluetoothIndicatorServicesDevice* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 70 "../src/Widgets/Device.vala"
		_tmp18_ = self->priv->_device;
#line 70 "../src/Widgets/Device.vala"
		_tmp19_ = bluetooth_indicator_services_device_get_icon (_tmp18_);
#line 70 "../src/Widgets/Device.vala"
		_tmp20_ = _tmp19_;
#line 70 "../src/Widgets/Device.vala"
		_g_free0 (_tmp11_);
#line 70 "../src/Widgets/Device.vala"
		_tmp11_ = _tmp20_;
#line 1715 "Device.c"
	}
#line 70 "../src/Widgets/Device.vala"
	_tmp21_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp11_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 70 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp21_);
#line 70 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->icon_image);
#line 70 "../src/Widgets/Device.vala"
	self->priv->icon_image = _tmp21_;
#line 72 "../src/Widgets/Device.vala"
	_tmp22_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 72 "../src/Widgets/Device.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_END);
#line 72 "../src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_END);
#line 72 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp22_);
#line 72 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->status_image);
#line 72 "../src/Widgets/Device.vala"
	self->priv->status_image = _tmp22_;
#line 77 "../src/Widgets/Device.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new (NULL);
#line 77 "../src/Widgets/Device.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_START);
#line 77 "../src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp23_, GTK_ALIGN_END);
#line 77 "../src/Widgets/Device.vala"
	gtk_label_set_use_markup (_tmp23_, TRUE);
#line 77 "../src/Widgets/Device.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp23_, TRUE);
#line 77 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp23_);
#line 77 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->progress_label);
#line 77 "../src/Widgets/Device.vala"
	self->priv->progress_label = _tmp23_;
#line 84 "../src/Widgets/Device.vala"
	_tmp24_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 84 "../src/Widgets/Device.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, TRUE);
#line 84 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp24_);
#line 84 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->progressbar);
#line 84 "../src/Widgets/Device.vala"
	self->priv->progressbar = _tmp24_;
#line 88 "../src/Widgets/Device.vala"
	_tmp25_ = (GtkLabel*) gtk_label_new (NULL);
#line 88 "../src/Widgets/Device.vala"
	gtk_label_set_ellipsize (_tmp25_, PANGO_ELLIPSIZE_MIDDLE);
#line 88 "../src/Widgets/Device.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_START);
#line 88 "../src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_END);
#line 88 "../src/Widgets/Device.vala"
	gtk_label_set_use_markup (_tmp25_, TRUE);
#line 88 "../src/Widgets/Device.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
#line 88 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp25_);
#line 88 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->file_label);
#line 88 "../src/Widgets/Device.vala"
	self->priv->file_label = _tmp25_;
#line 96 "../src/Widgets/Device.vala"
	_tmp26_ = (GtkGrid*) gtk_grid_new ();
#line 96 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp26_);
#line 96 "../src/Widgets/Device.vala"
	content_grid = _tmp26_;
#line 97 "../src/Widgets/Device.vala"
	_tmp27_ = content_grid;
#line 97 "../src/Widgets/Device.vala"
	_tmp28_ = self->priv->file_label;
#line 97 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 0, 0, 1, 1);
#line 98 "../src/Widgets/Device.vala"
	_tmp29_ = content_grid;
#line 98 "../src/Widgets/Device.vala"
	_tmp30_ = self->priv->progressbar;
#line 98 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 0, 1, 1, 1);
#line 99 "../src/Widgets/Device.vala"
	_tmp31_ = content_grid;
#line 99 "../src/Widgets/Device.vala"
	_tmp32_ = self->priv->progress_label;
#line 99 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 2, 1, 1);
#line 101 "../src/Widgets/Device.vala"
	_tmp33_ = (GtkRevealer*) gtk_revealer_new ();
#line 101 "../src/Widgets/Device.vala"
	gtk_revealer_set_transition_type (_tmp33_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 101 "../src/Widgets/Device.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp33_, 5);
#line 101 "../src/Widgets/Device.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp33_, 5);
#line 101 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp33_);
#line 101 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->progress_revealer);
#line 101 "../src/Widgets/Device.vala"
	self->priv->progress_revealer = _tmp33_;
#line 106 "../src/Widgets/Device.vala"
	_tmp34_ = self->priv->progress_revealer;
#line 106 "../src/Widgets/Device.vala"
	_tmp35_ = content_grid;
#line 106 "../src/Widgets/Device.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 108 "../src/Widgets/Device.vala"
	_tmp36_ = (GtkOverlay*) gtk_overlay_new ();
#line 108 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp36_);
#line 108 "../src/Widgets/Device.vala"
	overlay = _tmp36_;
#line 109 "../src/Widgets/Device.vala"
	_tmp37_ = overlay;
#line 109 "../src/Widgets/Device.vala"
	_tmp38_ = self->priv->icon_image;
#line 109 "../src/Widgets/Device.vala"
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 110 "../src/Widgets/Device.vala"
	_tmp39_ = overlay;
#line 110 "../src/Widgets/Device.vala"
	_tmp40_ = self->priv->status_image;
#line 110 "../src/Widgets/Device.vala"
	gtk_overlay_add_overlay (_tmp39_, (GtkWidget*) _tmp40_);
#line 112 "../src/Widgets/Device.vala"
	_tmp41_ = (GtkGrid*) gtk_grid_new ();
#line 112 "../src/Widgets/Device.vala"
	gtk_grid_set_column_spacing (_tmp41_, 5);
#line 112 "../src/Widgets/Device.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp41_, 5);
#line 112 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp41_);
#line 112 "../src/Widgets/Device.vala"
	grid = _tmp41_;
#line 116 "../src/Widgets/Device.vala"
	_tmp42_ = grid;
#line 116 "../src/Widgets/Device.vala"
	_tmp43_ = overlay;
#line 116 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 0, 0, 1, 2);
#line 117 "../src/Widgets/Device.vala"
	_tmp44_ = grid;
#line 117 "../src/Widgets/Device.vala"
	_tmp45_ = self->priv->name_label;
#line 117 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 1, 0, 2, 1);
#line 118 "../src/Widgets/Device.vala"
	_tmp46_ = grid;
#line 118 "../src/Widgets/Device.vala"
	_tmp47_ = self->priv->status_label;
#line 118 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, 1, 1, 1, 1);
#line 119 "../src/Widgets/Device.vala"
	_tmp48_ = grid;
#line 119 "../src/Widgets/Device.vala"
	_tmp49_ = self->priv->spinner;
#line 119 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp48_, (GtkWidget*) _tmp49_, 2, 1, 1, 1);
#line 121 "../src/Widgets/Device.vala"
	_tmp50_ = (GtkGrid*) gtk_grid_new ();
#line 121 "../src/Widgets/Device.vala"
	g_object_ref_sink (_tmp50_);
#line 121 "../src/Widgets/Device.vala"
	box_grid = _tmp50_;
#line 122 "../src/Widgets/Device.vala"
	_tmp51_ = box_grid;
#line 122 "../src/Widgets/Device.vala"
	_tmp52_ = grid;
#line 122 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 0, 0, 1, 1);
#line 123 "../src/Widgets/Device.vala"
	_tmp53_ = box_grid;
#line 123 "../src/Widgets/Device.vala"
	_tmp54_ = self->priv->progress_revealer;
#line 123 "../src/Widgets/Device.vala"
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 0, 1, 1, 1);
#line 124 "../src/Widgets/Device.vala"
	_tmp55_ = box_grid;
#line 124 "../src/Widgets/Device.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp55_);
#line 126 "../src/Widgets/Device.vala"
	_tmp56_ = self->priv->_device;
#line 126 "../src/Widgets/Device.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) _bluetooth_indicator_widgets_device_update_status_g_dbus_proxy_g_properties_changed, self, 0);
#line 128 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_update_status (self);
#line 129 "../src/Widgets/Device.vala"
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 129 "../src/Widgets/Device.vala"
	gtk_style_context_add_class (_tmp57_, GTK_STYLE_CLASS_MENUITEM);
#line 130 "../src/Widgets/Device.vala"
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, FALSE);
#line 131 "../src/Widgets/Device.vala"
	_tmp58_ = self->priv->_obex_manager;
#line 131 "../src/Widgets/Device.vala"
	_tmp59_ = _tmp58_->active_transfers;
#line 131 "../src/Widgets/Device.vala"
	g_hash_table_foreach (_tmp59_, __bluetooth_indicator_widgets_device___lambda22__gh_func, self);
#line 42 "../src/Widgets/Device.vala"
	_g_object_unref0 (box_grid);
#line 42 "../src/Widgets/Device.vala"
	_g_object_unref0 (grid);
#line 42 "../src/Widgets/Device.vala"
	_g_object_unref0 (overlay);
#line 42 "../src/Widgets/Device.vala"
	_g_object_unref0 (content_grid);
#line 42 "../src/Widgets/Device.vala"
	_g_free0 (_tmp11_);
#line 42 "../src/Widgets/Device.vala"
	_g_object_unref0 (size_group);
#line 42 "../src/Widgets/Device.vala"
	return obj;
#line 1931 "Device.c"
}

static void
bluetooth_indicator_widgets_device_class_init (BluetoothIndicatorWidgetsDeviceClass * klass,
                                               gpointer klass_data)
{
#line 18 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Widgets/Device.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothIndicatorWidgetsDevice_private_offset);
#line 18 "../src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_indicator_widgets_device_get_property;
#line 18 "../src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_indicator_widgets_device_set_property;
#line 18 "../src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_indicator_widgets_device_constructor;
#line 18 "../src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_indicator_widgets_device_finalize;
#line 18 "../src/Widgets/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEVICE_PROPERTY, bluetooth_indicator_widgets_device_properties[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_INDICATOR_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/Widgets/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_MANAGER_PROPERTY, bluetooth_indicator_widgets_device_properties[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_MANAGER_PROPERTY] = g_param_spec_object ("obex-manager", "obex-manager", "obex-manager", BLUETOOTH_INDICATOR_SERVICES_TYPE_OBEX_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/Widgets/Device.vala"
	bluetooth_indicator_widgets_device_signals[BLUETOOTH_INDICATOR_WIDGETS_DEVICE_SHOW_DEVICE_SIGNAL] = g_signal_new ("show-device", BLUETOOTH_INDICATOR_WIDGETS_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BLUETOOTH_INDICATOR_SERVICES_TYPE_DEVICE);
#line 1956 "Device.c"
}

static void
bluetooth_indicator_widgets_device_instance_init (BluetoothIndicatorWidgetsDevice * self,
                                                  gpointer klass)
{
#line 18 "../src/Widgets/Device.vala"
	self->priv = bluetooth_indicator_widgets_device_get_instance_private (self);
#line 1965 "Device.c"
}

static void
bluetooth_indicator_widgets_device_finalize (GObject * obj)
{
	BluetoothIndicatorWidgetsDevice * self;
#line 18 "../src/Widgets/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_INDICATOR_WIDGETS_TYPE_DEVICE, BluetoothIndicatorWidgetsDevice);
#line 23 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->_device);
#line 24 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->_obex_manager);
#line 25 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->transfer);
#line 26 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->status_label);
#line 27 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->name_label);
#line 28 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->progress_label);
#line 29 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->file_label);
#line 30 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->icon_image);
#line 31 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->status_image);
#line 32 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->spinner);
#line 33 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->progress_revealer);
#line 34 "../src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->progressbar);
#line 18 "../src/Widgets/Device.vala"
	G_OBJECT_CLASS (bluetooth_indicator_widgets_device_parent_class)->finalize (obj);
#line 2000 "Device.c"
}

static GType
bluetooth_indicator_widgets_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothIndicatorWidgetsDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_indicator_widgets_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothIndicatorWidgetsDevice), 0, (GInstanceInitFunc) bluetooth_indicator_widgets_device_instance_init, NULL };
	GType bluetooth_indicator_widgets_device_type_id;
	bluetooth_indicator_widgets_device_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothIndicatorWidgetsDevice", &g_define_type_info, 0);
	BluetoothIndicatorWidgetsDevice_private_offset = g_type_add_instance_private (bluetooth_indicator_widgets_device_type_id, sizeof (BluetoothIndicatorWidgetsDevicePrivate));
	return bluetooth_indicator_widgets_device_type_id;
}

GType
bluetooth_indicator_widgets_device_get_type (void)
{
	static volatile gsize bluetooth_indicator_widgets_device_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_indicator_widgets_device_type_id__once)) {
		GType bluetooth_indicator_widgets_device_type_id;
		bluetooth_indicator_widgets_device_type_id = bluetooth_indicator_widgets_device_get_type_once ();
		g_once_init_leave (&bluetooth_indicator_widgets_device_type_id__once, bluetooth_indicator_widgets_device_type_id);
	}
	return bluetooth_indicator_widgets_device_type_id__once;
}

static void
_vala_bluetooth_indicator_widgets_device_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	BluetoothIndicatorWidgetsDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_INDICATOR_WIDGETS_TYPE_DEVICE, BluetoothIndicatorWidgetsDevice);
#line 18 "../src/Widgets/Device.vala"
	switch (property_id) {
#line 18 "../src/Widgets/Device.vala"
		case BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEVICE_PROPERTY:
#line 18 "../src/Widgets/Device.vala"
		g_value_set_object (value, bluetooth_indicator_widgets_device_get_device (self));
#line 18 "../src/Widgets/Device.vala"
		break;
#line 18 "../src/Widgets/Device.vala"
		case BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_MANAGER_PROPERTY:
#line 18 "../src/Widgets/Device.vala"
		g_value_set_object (value, bluetooth_indicator_widgets_device_get_obex_manager (self));
#line 18 "../src/Widgets/Device.vala"
		break;
#line 2047 "Device.c"
		default:
#line 18 "../src/Widgets/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/Device.vala"
		break;
#line 2053 "Device.c"
	}
}

static void
_vala_bluetooth_indicator_widgets_device_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	BluetoothIndicatorWidgetsDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_INDICATOR_WIDGETS_TYPE_DEVICE, BluetoothIndicatorWidgetsDevice);
#line 18 "../src/Widgets/Device.vala"
	switch (property_id) {
#line 18 "../src/Widgets/Device.vala"
		case BLUETOOTH_INDICATOR_WIDGETS_DEVICE_DEVICE_PROPERTY:
#line 18 "../src/Widgets/Device.vala"
		bluetooth_indicator_widgets_device_set_device (self, g_value_get_object (value));
#line 18 "../src/Widgets/Device.vala"
		break;
#line 18 "../src/Widgets/Device.vala"
		case BLUETOOTH_INDICATOR_WIDGETS_DEVICE_OBEX_MANAGER_PROPERTY:
#line 18 "../src/Widgets/Device.vala"
		bluetooth_indicator_widgets_device_set_obex_manager (self, g_value_get_object (value));
#line 18 "../src/Widgets/Device.vala"
		break;
#line 2079 "Device.c"
		default:
#line 18 "../src/Widgets/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/Device.vala"
		break;
#line 2085 "Device.c"
	}
}

